
#include <linux/types.h>
#include <asm/bootinfo.h>

#include "nonstdio.h"
#include "gt64260_i2c.h"

#define ENET_MAC_LEN	6
#define GT64260_SETUP	"gt_mac"


static unsigned char *
mac2hex(unsigned char *bfr, unsigned char *mac)
{
	unsigned char table[] = "0123456789ABCDEF";
	int i;

	for (i = 0; i < ENET_MAC_LEN; i++) {

		*bfr++ = table[(*mac & 0xF0) >> 4]; 
		*bfr++ = table[*mac & 0x0F]; 
		mac++;
	}
	return bfr;
}

void
birec_add_hook(struct bi_record *birecs)
{

	unsigned char enet_bfr[3*ENET_MAC_LEN] = { 0 };
	unsigned char i2c_addr[] = { 0x51, 0x00 };
	int i;

	gt64260_i2c_init();

	gt64260_i2c_read(i2c_addr, 2, enet_bfr, sizeof(enet_bfr));

	for (i = 0; i < 3; i++) {

		unsigned char bfr[30] = "gt_mac";
		unsigned char *ptr;

		ptr = bfr + strlen(bfr);
		*ptr++ = '0' + i;
		*ptr++ = '=';
		ptr = mac2hex(ptr, &enet_bfr[i*ENET_MAC_LEN]);
		*ptr = '\0';

		bootinfo_append(BI_SETUP_LINE, strlen(bfr)+1, (void *) bfr);

	}
}
