/*
 *
 * "Indirect" SPR access
 *
 * Copyright (c) 2004 Eugene Surovegin <ebs@ebshome.net>
 *
 * This program is free software; you can redistribute it and/or modify it
 * under  the terms of  the GNU General Public License as published by the
 * Free Software Foundation;  either version 2 of the License, or (at your
 * option) any later version.
 */

#include <asm/ppc_asm.h>
#include <asm/processor.h>

#define SPR_ACCESS_PROLOG(table) \
	rlwinm  r3,r3,4,18,27;   \
	lis     r5,table@h;      \
	ori     r5,r5,table@l;   \
	add     r3,r3,r5;        \
	mtctr   r3;              \
	bctr

_GLOBAL(__mfspr)
	SPR_ACCESS_PROLOG(__mfspr_table)

_GLOBAL(__mtspr)
	SPR_ACCESS_PROLOG(__mtspr_table)

__mfspr_table:
	mfspr  r3,0; blr
__mtspr_table:	
	mtspr  0,r4; blr
	mfspr  r3,1; blr
	mtspr  1,r4; blr
	mfspr  r3,2; blr
	mtspr  2,r4; blr
	mfspr  r3,3; blr
	mtspr  3,r4; blr
	mfspr  r3,4; blr
	mtspr  4,r4; blr
	mfspr  r3,5; blr
	mtspr  5,r4; blr
	mfspr  r3,6; blr
	mtspr  6,r4; blr
	mfspr  r3,7; blr
	mtspr  7,r4; blr
	mfspr  r3,8; blr
	mtspr  8,r4; blr
	mfspr  r3,9; blr
	mtspr  9,r4; blr
	mfspr  r3,10; blr
	mtspr  10,r4; blr
	mfspr  r3,11; blr
	mtspr  11,r4; blr
	mfspr  r3,12; blr
	mtspr  12,r4; blr
	mfspr  r3,13; blr
	mtspr  13,r4; blr
	mfspr  r3,14; blr
	mtspr  14,r4; blr
	mfspr  r3,15; blr
	mtspr  15,r4; blr
	mfspr  r3,16; blr
	mtspr  16,r4; blr
	mfspr  r3,17; blr
	mtspr  17,r4; blr
	mfspr  r3,18; blr
	mtspr  18,r4; blr
	mfspr  r3,19; blr
	mtspr  19,r4; blr
	mfspr  r3,20; blr
	mtspr  20,r4; blr
	mfspr  r3,21; blr
	mtspr  21,r4; blr
	mfspr  r3,22; blr
	mtspr  22,r4; blr
	mfspr  r3,23; blr
	mtspr  23,r4; blr
	mfspr  r3,24; blr
	mtspr  24,r4; blr
	mfspr  r3,25; blr
	mtspr  25,r4; blr
	mfspr  r3,26; blr
	mtspr  26,r4; blr
	mfspr  r3,27; blr
	mtspr  27,r4; blr
	mfspr  r3,28; blr
	mtspr  28,r4; blr
	mfspr  r3,29; blr
	mtspr  29,r4; blr
	mfspr  r3,30; blr
	mtspr  30,r4; blr
	mfspr  r3,31; blr
	mtspr  31,r4; blr
	mfspr  r3,32; blr
	mtspr  32,r4; blr
	mfspr  r3,33; blr
	mtspr  33,r4; blr
	mfspr  r3,34; blr
	mtspr  34,r4; blr
	mfspr  r3,35; blr
	mtspr  35,r4; blr
	mfspr  r3,36; blr
	mtspr  36,r4; blr
	mfspr  r3,37; blr
	mtspr  37,r4; blr
	mfspr  r3,38; blr
	mtspr  38,r4; blr
	mfspr  r3,39; blr
	mtspr  39,r4; blr
	mfspr  r3,40; blr
	mtspr  40,r4; blr
	mfspr  r3,41; blr
	mtspr  41,r4; blr
	mfspr  r3,42; blr
	mtspr  42,r4; blr
	mfspr  r3,43; blr
	mtspr  43,r4; blr
	mfspr  r3,44; blr
	mtspr  44,r4; blr
	mfspr  r3,45; blr
	mtspr  45,r4; blr
	mfspr  r3,46; blr
	mtspr  46,r4; blr
	mfspr  r3,47; blr
	mtspr  47,r4; blr
	mfspr  r3,48; blr
	mtspr  48,r4; blr
	mfspr  r3,49; blr
	mtspr  49,r4; blr
	mfspr  r3,50; blr
	mtspr  50,r4; blr
	mfspr  r3,51; blr
	mtspr  51,r4; blr
	mfspr  r3,52; blr
	mtspr  52,r4; blr
	mfspr  r3,53; blr
	mtspr  53,r4; blr
	mfspr  r3,54; blr
	mtspr  54,r4; blr
	mfspr  r3,55; blr
	mtspr  55,r4; blr
	mfspr  r3,56; blr
	mtspr  56,r4; blr
	mfspr  r3,57; blr
	mtspr  57,r4; blr
	mfspr  r3,58; blr
	mtspr  58,r4; blr
	mfspr  r3,59; blr
	mtspr  59,r4; blr
	mfspr  r3,60; blr
	mtspr  60,r4; blr
	mfspr  r3,61; blr
	mtspr  61,r4; blr
	mfspr  r3,62; blr
	mtspr  62,r4; blr
	mfspr  r3,63; blr
	mtspr  63,r4; blr
	mfspr  r3,64; blr
	mtspr  64,r4; blr
	mfspr  r3,65; blr
	mtspr  65,r4; blr
	mfspr  r3,66; blr
	mtspr  66,r4; blr
	mfspr  r3,67; blr
	mtspr  67,r4; blr
	mfspr  r3,68; blr
	mtspr  68,r4; blr
	mfspr  r3,69; blr
	mtspr  69,r4; blr
	mfspr  r3,70; blr
	mtspr  70,r4; blr
	mfspr  r3,71; blr
	mtspr  71,r4; blr
	mfspr  r3,72; blr
	mtspr  72,r4; blr
	mfspr  r3,73; blr
	mtspr  73,r4; blr
	mfspr  r3,74; blr
	mtspr  74,r4; blr
	mfspr  r3,75; blr
	mtspr  75,r4; blr
	mfspr  r3,76; blr
	mtspr  76,r4; blr
	mfspr  r3,77; blr
	mtspr  77,r4; blr
	mfspr  r3,78; blr
	mtspr  78,r4; blr
	mfspr  r3,79; blr
	mtspr  79,r4; blr
	mfspr  r3,80; blr
	mtspr  80,r4; blr
	mfspr  r3,81; blr
	mtspr  81,r4; blr
	mfspr  r3,82; blr
	mtspr  82,r4; blr
	mfspr  r3,83; blr
	mtspr  83,r4; blr
	mfspr  r3,84; blr
	mtspr  84,r4; blr
	mfspr  r3,85; blr
	mtspr  85,r4; blr
	mfspr  r3,86; blr
	mtspr  86,r4; blr
	mfspr  r3,87; blr
	mtspr  87,r4; blr
	mfspr  r3,88; blr
	mtspr  88,r4; blr
	mfspr  r3,89; blr
	mtspr  89,r4; blr
	mfspr  r3,90; blr
	mtspr  90,r4; blr
	mfspr  r3,91; blr
	mtspr  91,r4; blr
	mfspr  r3,92; blr
	mtspr  92,r4; blr
	mfspr  r3,93; blr
	mtspr  93,r4; blr
	mfspr  r3,94; blr
	mtspr  94,r4; blr
	mfspr  r3,95; blr
	mtspr  95,r4; blr
	mfspr  r3,96; blr
	mtspr  96,r4; blr
	mfspr  r3,97; blr
	mtspr  97,r4; blr
	mfspr  r3,98; blr
	mtspr  98,r4; blr
	mfspr  r3,99; blr
	mtspr  99,r4; blr
	mfspr  r3,100; blr
	mtspr  100,r4; blr
	mfspr  r3,101; blr
	mtspr  101,r4; blr
	mfspr  r3,102; blr
	mtspr  102,r4; blr
	mfspr  r3,103; blr
	mtspr  103,r4; blr
	mfspr  r3,104; blr
	mtspr  104,r4; blr
	mfspr  r3,105; blr
	mtspr  105,r4; blr
	mfspr  r3,106; blr
	mtspr  106,r4; blr
	mfspr  r3,107; blr
	mtspr  107,r4; blr
	mfspr  r3,108; blr
	mtspr  108,r4; blr
	mfspr  r3,109; blr
	mtspr  109,r4; blr
	mfspr  r3,110; blr
	mtspr  110,r4; blr
	mfspr  r3,111; blr
	mtspr  111,r4; blr
	mfspr  r3,112; blr
	mtspr  112,r4; blr
	mfspr  r3,113; blr
	mtspr  113,r4; blr
	mfspr  r3,114; blr
	mtspr  114,r4; blr
	mfspr  r3,115; blr
	mtspr  115,r4; blr
	mfspr  r3,116; blr
	mtspr  116,r4; blr
	mfspr  r3,117; blr
	mtspr  117,r4; blr
	mfspr  r3,118; blr
	mtspr  118,r4; blr
	mfspr  r3,119; blr
	mtspr  119,r4; blr
	mfspr  r3,120; blr
	mtspr  120,r4; blr
	mfspr  r3,121; blr
	mtspr  121,r4; blr
	mfspr  r3,122; blr
	mtspr  122,r4; blr
	mfspr  r3,123; blr
	mtspr  123,r4; blr
	mfspr  r3,124; blr
	mtspr  124,r4; blr
	mfspr  r3,125; blr
	mtspr  125,r4; blr
	mfspr  r3,126; blr
	mtspr  126,r4; blr
	mfspr  r3,127; blr
	mtspr  127,r4; blr
	mfspr  r3,128; blr
	mtspr  128,r4; blr
	mfspr  r3,129; blr
	mtspr  129,r4; blr
	mfspr  r3,130; blr
	mtspr  130,r4; blr
	mfspr  r3,131; blr
	mtspr  131,r4; blr
	mfspr  r3,132; blr
	mtspr  132,r4; blr
	mfspr  r3,133; blr
	mtspr  133,r4; blr
	mfspr  r3,134; blr
	mtspr  134,r4; blr
	mfspr  r3,135; blr
	mtspr  135,r4; blr
	mfspr  r3,136; blr
	mtspr  136,r4; blr
	mfspr  r3,137; blr
	mtspr  137,r4; blr
	mfspr  r3,138; blr
	mtspr  138,r4; blr
	mfspr  r3,139; blr
	mtspr  139,r4; blr
	mfspr  r3,140; blr
	mtspr  140,r4; blr
	mfspr  r3,141; blr
	mtspr  141,r4; blr
	mfspr  r3,142; blr
	mtspr  142,r4; blr
	mfspr  r3,143; blr
	mtspr  143,r4; blr
	mfspr  r3,144; blr
	mtspr  144,r4; blr
	mfspr  r3,145; blr
	mtspr  145,r4; blr
	mfspr  r3,146; blr
	mtspr  146,r4; blr
	mfspr  r3,147; blr
	mtspr  147,r4; blr
	mfspr  r3,148; blr
	mtspr  148,r4; blr
	mfspr  r3,149; blr
	mtspr  149,r4; blr
	mfspr  r3,150; blr
	mtspr  150,r4; blr
	mfspr  r3,151; blr
	mtspr  151,r4; blr
	mfspr  r3,152; blr
	mtspr  152,r4; blr
	mfspr  r3,153; blr
	mtspr  153,r4; blr
	mfspr  r3,154; blr
	mtspr  154,r4; blr
	mfspr  r3,155; blr
	mtspr  155,r4; blr
	mfspr  r3,156; blr
	mtspr  156,r4; blr
	mfspr  r3,157; blr
	mtspr  157,r4; blr
	mfspr  r3,158; blr
	mtspr  158,r4; blr
	mfspr  r3,159; blr
	mtspr  159,r4; blr
	mfspr  r3,160; blr
	mtspr  160,r4; blr
	mfspr  r3,161; blr
	mtspr  161,r4; blr
	mfspr  r3,162; blr
	mtspr  162,r4; blr
	mfspr  r3,163; blr
	mtspr  163,r4; blr
	mfspr  r3,164; blr
	mtspr  164,r4; blr
	mfspr  r3,165; blr
	mtspr  165,r4; blr
	mfspr  r3,166; blr
	mtspr  166,r4; blr
	mfspr  r3,167; blr
	mtspr  167,r4; blr
	mfspr  r3,168; blr
	mtspr  168,r4; blr
	mfspr  r3,169; blr
	mtspr  169,r4; blr
	mfspr  r3,170; blr
	mtspr  170,r4; blr
	mfspr  r3,171; blr
	mtspr  171,r4; blr
	mfspr  r3,172; blr
	mtspr  172,r4; blr
	mfspr  r3,173; blr
	mtspr  173,r4; blr
	mfspr  r3,174; blr
	mtspr  174,r4; blr
	mfspr  r3,175; blr
	mtspr  175,r4; blr
	mfspr  r3,176; blr
	mtspr  176,r4; blr
	mfspr  r3,177; blr
	mtspr  177,r4; blr
	mfspr  r3,178; blr
	mtspr  178,r4; blr
	mfspr  r3,179; blr
	mtspr  179,r4; blr
	mfspr  r3,180; blr
	mtspr  180,r4; blr
	mfspr  r3,181; blr
	mtspr  181,r4; blr
	mfspr  r3,182; blr
	mtspr  182,r4; blr
	mfspr  r3,183; blr
	mtspr  183,r4; blr
	mfspr  r3,184; blr
	mtspr  184,r4; blr
	mfspr  r3,185; blr
	mtspr  185,r4; blr
	mfspr  r3,186; blr
	mtspr  186,r4; blr
	mfspr  r3,187; blr
	mtspr  187,r4; blr
	mfspr  r3,188; blr
	mtspr  188,r4; blr
	mfspr  r3,189; blr
	mtspr  189,r4; blr
	mfspr  r3,190; blr
	mtspr  190,r4; blr
	mfspr  r3,191; blr
	mtspr  191,r4; blr
	mfspr  r3,192; blr
	mtspr  192,r4; blr
	mfspr  r3,193; blr
	mtspr  193,r4; blr
	mfspr  r3,194; blr
	mtspr  194,r4; blr
	mfspr  r3,195; blr
	mtspr  195,r4; blr
	mfspr  r3,196; blr
	mtspr  196,r4; blr
	mfspr  r3,197; blr
	mtspr  197,r4; blr
	mfspr  r3,198; blr
	mtspr  198,r4; blr
	mfspr  r3,199; blr
	mtspr  199,r4; blr
	mfspr  r3,200; blr
	mtspr  200,r4; blr
	mfspr  r3,201; blr
	mtspr  201,r4; blr
	mfspr  r3,202; blr
	mtspr  202,r4; blr
	mfspr  r3,203; blr
	mtspr  203,r4; blr
	mfspr  r3,204; blr
	mtspr  204,r4; blr
	mfspr  r3,205; blr
	mtspr  205,r4; blr
	mfspr  r3,206; blr
	mtspr  206,r4; blr
	mfspr  r3,207; blr
	mtspr  207,r4; blr
	mfspr  r3,208; blr
	mtspr  208,r4; blr
	mfspr  r3,209; blr
	mtspr  209,r4; blr
	mfspr  r3,210; blr
	mtspr  210,r4; blr
	mfspr  r3,211; blr
	mtspr  211,r4; blr
	mfspr  r3,212; blr
	mtspr  212,r4; blr
	mfspr  r3,213; blr
	mtspr  213,r4; blr
	mfspr  r3,214; blr
	mtspr  214,r4; blr
	mfspr  r3,215; blr
	mtspr  215,r4; blr
	mfspr  r3,216; blr
	mtspr  216,r4; blr
	mfspr  r3,217; blr
	mtspr  217,r4; blr
	mfspr  r3,218; blr
	mtspr  218,r4; blr
	mfspr  r3,219; blr
	mtspr  219,r4; blr
	mfspr  r3,220; blr
	mtspr  220,r4; blr
	mfspr  r3,221; blr
	mtspr  221,r4; blr
	mfspr  r3,222; blr
	mtspr  222,r4; blr
	mfspr  r3,223; blr
	mtspr  223,r4; blr
	mfspr  r3,224; blr
	mtspr  224,r4; blr
	mfspr  r3,225; blr
	mtspr  225,r4; blr
	mfspr  r3,226; blr
	mtspr  226,r4; blr
	mfspr  r3,227; blr
	mtspr  227,r4; blr
	mfspr  r3,228; blr
	mtspr  228,r4; blr
	mfspr  r3,229; blr
	mtspr  229,r4; blr
	mfspr  r3,230; blr
	mtspr  230,r4; blr
	mfspr  r3,231; blr
	mtspr  231,r4; blr
	mfspr  r3,232; blr
	mtspr  232,r4; blr
	mfspr  r3,233; blr
	mtspr  233,r4; blr
	mfspr  r3,234; blr
	mtspr  234,r4; blr
	mfspr  r3,235; blr
	mtspr  235,r4; blr
	mfspr  r3,236; blr
	mtspr  236,r4; blr
	mfspr  r3,237; blr
	mtspr  237,r4; blr
	mfspr  r3,238; blr
	mtspr  238,r4; blr
	mfspr  r3,239; blr
	mtspr  239,r4; blr
	mfspr  r3,240; blr
	mtspr  240,r4; blr
	mfspr  r3,241; blr
	mtspr  241,r4; blr
	mfspr  r3,242; blr
	mtspr  242,r4; blr
	mfspr  r3,243; blr
	mtspr  243,r4; blr
	mfspr  r3,244; blr
	mtspr  244,r4; blr
	mfspr  r3,245; blr
	mtspr  245,r4; blr
	mfspr  r3,246; blr
	mtspr  246,r4; blr
	mfspr  r3,247; blr
	mtspr  247,r4; blr
	mfspr  r3,248; blr
	mtspr  248,r4; blr
	mfspr  r3,249; blr
	mtspr  249,r4; blr
	mfspr  r3,250; blr
	mtspr  250,r4; blr
	mfspr  r3,251; blr
	mtspr  251,r4; blr
	mfspr  r3,252; blr
	mtspr  252,r4; blr
	mfspr  r3,253; blr
	mtspr  253,r4; blr
	mfspr  r3,254; blr
	mtspr  254,r4; blr
	mfspr  r3,255; blr
	mtspr  255,r4; blr
	mfspr  r3,256; blr
	mtspr  256,r4; blr
	mfspr  r3,257; blr
	mtspr  257,r4; blr
	mfspr  r3,258; blr
	mtspr  258,r4; blr
	mfspr  r3,259; blr
	mtspr  259,r4; blr
	mfspr  r3,260; blr
	mtspr  260,r4; blr
	mfspr  r3,261; blr
	mtspr  261,r4; blr
	mfspr  r3,262; blr
	mtspr  262,r4; blr
	mfspr  r3,263; blr
	mtspr  263,r4; blr
	mfspr  r3,264; blr
	mtspr  264,r4; blr
	mfspr  r3,265; blr
	mtspr  265,r4; blr
	mfspr  r3,266; blr
	mtspr  266,r4; blr
	mfspr  r3,267; blr
	mtspr  267,r4; blr
	mfspr  r3,268; blr
	mtspr  268,r4; blr
	mfspr  r3,269; blr
	mtspr  269,r4; blr
	mfspr  r3,270; blr
	mtspr  270,r4; blr
	mfspr  r3,271; blr
	mtspr  271,r4; blr
	mfspr  r3,272; blr
	mtspr  272,r4; blr
	mfspr  r3,273; blr
	mtspr  273,r4; blr
	mfspr  r3,274; blr
	mtspr  274,r4; blr
	mfspr  r3,275; blr
	mtspr  275,r4; blr
	mfspr  r3,276; blr
	mtspr  276,r4; blr
	mfspr  r3,277; blr
	mtspr  277,r4; blr
	mfspr  r3,278; blr
	mtspr  278,r4; blr
	mfspr  r3,279; blr
	mtspr  279,r4; blr
	mfspr  r3,280; blr
	mtspr  280,r4; blr
	mfspr  r3,281; blr
	mtspr  281,r4; blr
	mfspr  r3,282; blr
	mtspr  282,r4; blr
	mfspr  r3,283; blr
	mtspr  283,r4; blr
	mfspr  r3,284; blr
	mtspr  284,r4; blr
	mfspr  r3,285; blr
	mtspr  285,r4; blr
	mfspr  r3,286; blr
	mtspr  286,r4; blr
	mfspr  r3,287; blr
	mtspr  287,r4; blr
	mfspr  r3,288; blr
	mtspr  288,r4; blr
	mfspr  r3,289; blr
	mtspr  289,r4; blr
	mfspr  r3,290; blr
	mtspr  290,r4; blr
	mfspr  r3,291; blr
	mtspr  291,r4; blr
	mfspr  r3,292; blr
	mtspr  292,r4; blr
	mfspr  r3,293; blr
	mtspr  293,r4; blr
	mfspr  r3,294; blr
	mtspr  294,r4; blr
	mfspr  r3,295; blr
	mtspr  295,r4; blr
	mfspr  r3,296; blr
	mtspr  296,r4; blr
	mfspr  r3,297; blr
	mtspr  297,r4; blr
	mfspr  r3,298; blr
	mtspr  298,r4; blr
	mfspr  r3,299; blr
	mtspr  299,r4; blr
	mfspr  r3,300; blr
	mtspr  300,r4; blr
	mfspr  r3,301; blr
	mtspr  301,r4; blr
	mfspr  r3,302; blr
	mtspr  302,r4; blr
	mfspr  r3,303; blr
	mtspr  303,r4; blr
	mfspr  r3,304; blr
	mtspr  304,r4; blr
	mfspr  r3,305; blr
	mtspr  305,r4; blr
	mfspr  r3,306; blr
	mtspr  306,r4; blr
	mfspr  r3,307; blr
	mtspr  307,r4; blr
	mfspr  r3,308; blr
	mtspr  308,r4; blr
	mfspr  r3,309; blr
	mtspr  309,r4; blr
	mfspr  r3,310; blr
	mtspr  310,r4; blr
	mfspr  r3,311; blr
	mtspr  311,r4; blr
	mfspr  r3,312; blr
	mtspr  312,r4; blr
	mfspr  r3,313; blr
	mtspr  313,r4; blr
	mfspr  r3,314; blr
	mtspr  314,r4; blr
	mfspr  r3,315; blr
	mtspr  315,r4; blr
	mfspr  r3,316; blr
	mtspr  316,r4; blr
	mfspr  r3,317; blr
	mtspr  317,r4; blr
	mfspr  r3,318; blr
	mtspr  318,r4; blr
	mfspr  r3,319; blr
	mtspr  319,r4; blr
	mfspr  r3,320; blr
	mtspr  320,r4; blr
	mfspr  r3,321; blr
	mtspr  321,r4; blr
	mfspr  r3,322; blr
	mtspr  322,r4; blr
	mfspr  r3,323; blr
	mtspr  323,r4; blr
	mfspr  r3,324; blr
	mtspr  324,r4; blr
	mfspr  r3,325; blr
	mtspr  325,r4; blr
	mfspr  r3,326; blr
	mtspr  326,r4; blr
	mfspr  r3,327; blr
	mtspr  327,r4; blr
	mfspr  r3,328; blr
	mtspr  328,r4; blr
	mfspr  r3,329; blr
	mtspr  329,r4; blr
	mfspr  r3,330; blr
	mtspr  330,r4; blr
	mfspr  r3,331; blr
	mtspr  331,r4; blr
	mfspr  r3,332; blr
	mtspr  332,r4; blr
	mfspr  r3,333; blr
	mtspr  333,r4; blr
	mfspr  r3,334; blr
	mtspr  334,r4; blr
	mfspr  r3,335; blr
	mtspr  335,r4; blr
	mfspr  r3,336; blr
	mtspr  336,r4; blr
	mfspr  r3,337; blr
	mtspr  337,r4; blr
	mfspr  r3,338; blr
	mtspr  338,r4; blr
	mfspr  r3,339; blr
	mtspr  339,r4; blr
	mfspr  r3,340; blr
	mtspr  340,r4; blr
	mfspr  r3,341; blr
	mtspr  341,r4; blr
	mfspr  r3,342; blr
	mtspr  342,r4; blr
	mfspr  r3,343; blr
	mtspr  343,r4; blr
	mfspr  r3,344; blr
	mtspr  344,r4; blr
	mfspr  r3,345; blr
	mtspr  345,r4; blr
	mfspr  r3,346; blr
	mtspr  346,r4; blr
	mfspr  r3,347; blr
	mtspr  347,r4; blr
	mfspr  r3,348; blr
	mtspr  348,r4; blr
	mfspr  r3,349; blr
	mtspr  349,r4; blr
	mfspr  r3,350; blr
	mtspr  350,r4; blr
	mfspr  r3,351; blr
	mtspr  351,r4; blr
	mfspr  r3,352; blr
	mtspr  352,r4; blr
	mfspr  r3,353; blr
	mtspr  353,r4; blr
	mfspr  r3,354; blr
	mtspr  354,r4; blr
	mfspr  r3,355; blr
	mtspr  355,r4; blr
	mfspr  r3,356; blr
	mtspr  356,r4; blr
	mfspr  r3,357; blr
	mtspr  357,r4; blr
	mfspr  r3,358; blr
	mtspr  358,r4; blr
	mfspr  r3,359; blr
	mtspr  359,r4; blr
	mfspr  r3,360; blr
	mtspr  360,r4; blr
	mfspr  r3,361; blr
	mtspr  361,r4; blr
	mfspr  r3,362; blr
	mtspr  362,r4; blr
	mfspr  r3,363; blr
	mtspr  363,r4; blr
	mfspr  r3,364; blr
	mtspr  364,r4; blr
	mfspr  r3,365; blr
	mtspr  365,r4; blr
	mfspr  r3,366; blr
	mtspr  366,r4; blr
	mfspr  r3,367; blr
	mtspr  367,r4; blr
	mfspr  r3,368; blr
	mtspr  368,r4; blr
	mfspr  r3,369; blr
	mtspr  369,r4; blr
	mfspr  r3,370; blr
	mtspr  370,r4; blr
	mfspr  r3,371; blr
	mtspr  371,r4; blr
	mfspr  r3,372; blr
	mtspr  372,r4; blr
	mfspr  r3,373; blr
	mtspr  373,r4; blr
	mfspr  r3,374; blr
	mtspr  374,r4; blr
	mfspr  r3,375; blr
	mtspr  375,r4; blr
	mfspr  r3,376; blr
	mtspr  376,r4; blr
	mfspr  r3,377; blr
	mtspr  377,r4; blr
	mfspr  r3,378; blr
	mtspr  378,r4; blr
	mfspr  r3,379; blr
	mtspr  379,r4; blr
	mfspr  r3,380; blr
	mtspr  380,r4; blr
	mfspr  r3,381; blr
	mtspr  381,r4; blr
	mfspr  r3,382; blr
	mtspr  382,r4; blr
	mfspr  r3,383; blr
	mtspr  383,r4; blr
	mfspr  r3,384; blr
	mtspr  384,r4; blr
	mfspr  r3,385; blr
	mtspr  385,r4; blr
	mfspr  r3,386; blr
	mtspr  386,r4; blr
	mfspr  r3,387; blr
	mtspr  387,r4; blr
	mfspr  r3,388; blr
	mtspr  388,r4; blr
	mfspr  r3,389; blr
	mtspr  389,r4; blr
	mfspr  r3,390; blr
	mtspr  390,r4; blr
	mfspr  r3,391; blr
	mtspr  391,r4; blr
	mfspr  r3,392; blr
	mtspr  392,r4; blr
	mfspr  r3,393; blr
	mtspr  393,r4; blr
	mfspr  r3,394; blr
	mtspr  394,r4; blr
	mfspr  r3,395; blr
	mtspr  395,r4; blr
	mfspr  r3,396; blr
	mtspr  396,r4; blr
	mfspr  r3,397; blr
	mtspr  397,r4; blr
	mfspr  r3,398; blr
	mtspr  398,r4; blr
	mfspr  r3,399; blr
	mtspr  399,r4; blr
	mfspr  r3,400; blr
	mtspr  400,r4; blr
	mfspr  r3,401; blr
	mtspr  401,r4; blr
	mfspr  r3,402; blr
	mtspr  402,r4; blr
	mfspr  r3,403; blr
	mtspr  403,r4; blr
	mfspr  r3,404; blr
	mtspr  404,r4; blr
	mfspr  r3,405; blr
	mtspr  405,r4; blr
	mfspr  r3,406; blr
	mtspr  406,r4; blr
	mfspr  r3,407; blr
	mtspr  407,r4; blr
	mfspr  r3,408; blr
	mtspr  408,r4; blr
	mfspr  r3,409; blr
	mtspr  409,r4; blr
	mfspr  r3,410; blr
	mtspr  410,r4; blr
	mfspr  r3,411; blr
	mtspr  411,r4; blr
	mfspr  r3,412; blr
	mtspr  412,r4; blr
	mfspr  r3,413; blr
	mtspr  413,r4; blr
	mfspr  r3,414; blr
	mtspr  414,r4; blr
	mfspr  r3,415; blr
	mtspr  415,r4; blr
	mfspr  r3,416; blr
	mtspr  416,r4; blr
	mfspr  r3,417; blr
	mtspr  417,r4; blr
	mfspr  r3,418; blr
	mtspr  418,r4; blr
	mfspr  r3,419; blr
	mtspr  419,r4; blr
	mfspr  r3,420; blr
	mtspr  420,r4; blr
	mfspr  r3,421; blr
	mtspr  421,r4; blr
	mfspr  r3,422; blr
	mtspr  422,r4; blr
	mfspr  r3,423; blr
	mtspr  423,r4; blr
	mfspr  r3,424; blr
	mtspr  424,r4; blr
	mfspr  r3,425; blr
	mtspr  425,r4; blr
	mfspr  r3,426; blr
	mtspr  426,r4; blr
	mfspr  r3,427; blr
	mtspr  427,r4; blr
	mfspr  r3,428; blr
	mtspr  428,r4; blr
	mfspr  r3,429; blr
	mtspr  429,r4; blr
	mfspr  r3,430; blr
	mtspr  430,r4; blr
	mfspr  r3,431; blr
	mtspr  431,r4; blr
	mfspr  r3,432; blr
	mtspr  432,r4; blr
	mfspr  r3,433; blr
	mtspr  433,r4; blr
	mfspr  r3,434; blr
	mtspr  434,r4; blr
	mfspr  r3,435; blr
	mtspr  435,r4; blr
	mfspr  r3,436; blr
	mtspr  436,r4; blr
	mfspr  r3,437; blr
	mtspr  437,r4; blr
	mfspr  r3,438; blr
	mtspr  438,r4; blr
	mfspr  r3,439; blr
	mtspr  439,r4; blr
	mfspr  r3,440; blr
	mtspr  440,r4; blr
	mfspr  r3,441; blr
	mtspr  441,r4; blr
	mfspr  r3,442; blr
	mtspr  442,r4; blr
	mfspr  r3,443; blr
	mtspr  443,r4; blr
	mfspr  r3,444; blr
	mtspr  444,r4; blr
	mfspr  r3,445; blr
	mtspr  445,r4; blr
	mfspr  r3,446; blr
	mtspr  446,r4; blr
	mfspr  r3,447; blr
	mtspr  447,r4; blr
	mfspr  r3,448; blr
	mtspr  448,r4; blr
	mfspr  r3,449; blr
	mtspr  449,r4; blr
	mfspr  r3,450; blr
	mtspr  450,r4; blr
	mfspr  r3,451; blr
	mtspr  451,r4; blr
	mfspr  r3,452; blr
	mtspr  452,r4; blr
	mfspr  r3,453; blr
	mtspr  453,r4; blr
	mfspr  r3,454; blr
	mtspr  454,r4; blr
	mfspr  r3,455; blr
	mtspr  455,r4; blr
	mfspr  r3,456; blr
	mtspr  456,r4; blr
	mfspr  r3,457; blr
	mtspr  457,r4; blr
	mfspr  r3,458; blr
	mtspr  458,r4; blr
	mfspr  r3,459; blr
	mtspr  459,r4; blr
	mfspr  r3,460; blr
	mtspr  460,r4; blr
	mfspr  r3,461; blr
	mtspr  461,r4; blr
	mfspr  r3,462; blr
	mtspr  462,r4; blr
	mfspr  r3,463; blr
	mtspr  463,r4; blr
	mfspr  r3,464; blr
	mtspr  464,r4; blr
	mfspr  r3,465; blr
	mtspr  465,r4; blr
	mfspr  r3,466; blr
	mtspr  466,r4; blr
	mfspr  r3,467; blr
	mtspr  467,r4; blr
	mfspr  r3,468; blr
	mtspr  468,r4; blr
	mfspr  r3,469; blr
	mtspr  469,r4; blr
	mfspr  r3,470; blr
	mtspr  470,r4; blr
	mfspr  r3,471; blr
	mtspr  471,r4; blr
	mfspr  r3,472; blr
	mtspr  472,r4; blr
	mfspr  r3,473; blr
	mtspr  473,r4; blr
	mfspr  r3,474; blr
	mtspr  474,r4; blr
	mfspr  r3,475; blr
	mtspr  475,r4; blr
	mfspr  r3,476; blr
	mtspr  476,r4; blr
	mfspr  r3,477; blr
	mtspr  477,r4; blr
	mfspr  r3,478; blr
	mtspr  478,r4; blr
	mfspr  r3,479; blr
	mtspr  479,r4; blr
	mfspr  r3,480; blr
	mtspr  480,r4; blr
	mfspr  r3,481; blr
	mtspr  481,r4; blr
	mfspr  r3,482; blr
	mtspr  482,r4; blr
	mfspr  r3,483; blr
	mtspr  483,r4; blr
	mfspr  r3,484; blr
	mtspr  484,r4; blr
	mfspr  r3,485; blr
	mtspr  485,r4; blr
	mfspr  r3,486; blr
	mtspr  486,r4; blr
	mfspr  r3,487; blr
	mtspr  487,r4; blr
	mfspr  r3,488; blr
	mtspr  488,r4; blr
	mfspr  r3,489; blr
	mtspr  489,r4; blr
	mfspr  r3,490; blr
	mtspr  490,r4; blr
	mfspr  r3,491; blr
	mtspr  491,r4; blr
	mfspr  r3,492; blr
	mtspr  492,r4; blr
	mfspr  r3,493; blr
	mtspr  493,r4; blr
	mfspr  r3,494; blr
	mtspr  494,r4; blr
	mfspr  r3,495; blr
	mtspr  495,r4; blr
	mfspr  r3,496; blr
	mtspr  496,r4; blr
	mfspr  r3,497; blr
	mtspr  497,r4; blr
	mfspr  r3,498; blr
	mtspr  498,r4; blr
	mfspr  r3,499; blr
	mtspr  499,r4; blr
	mfspr  r3,500; blr
	mtspr  500,r4; blr
	mfspr  r3,501; blr
	mtspr  501,r4; blr
	mfspr  r3,502; blr
	mtspr  502,r4; blr
	mfspr  r3,503; blr
	mtspr  503,r4; blr
	mfspr  r3,504; blr
	mtspr  504,r4; blr
	mfspr  r3,505; blr
	mtspr  505,r4; blr
	mfspr  r3,506; blr
	mtspr  506,r4; blr
	mfspr  r3,507; blr
	mtspr  507,r4; blr
	mfspr  r3,508; blr
	mtspr  508,r4; blr
	mfspr  r3,509; blr
	mtspr  509,r4; blr
	mfspr  r3,510; blr
	mtspr  510,r4; blr
	mfspr  r3,511; blr
	mtspr  511,r4; blr
	mfspr  r3,512; blr
	mtspr  512,r4; blr
	mfspr  r3,513; blr
	mtspr  513,r4; blr
	mfspr  r3,514; blr
	mtspr  514,r4; blr
	mfspr  r3,515; blr
	mtspr  515,r4; blr
	mfspr  r3,516; blr
	mtspr  516,r4; blr
	mfspr  r3,517; blr
	mtspr  517,r4; blr
	mfspr  r3,518; blr
	mtspr  518,r4; blr
	mfspr  r3,519; blr
	mtspr  519,r4; blr
	mfspr  r3,520; blr
	mtspr  520,r4; blr
	mfspr  r3,521; blr
	mtspr  521,r4; blr
	mfspr  r3,522; blr
	mtspr  522,r4; blr
	mfspr  r3,523; blr
	mtspr  523,r4; blr
	mfspr  r3,524; blr
	mtspr  524,r4; blr
	mfspr  r3,525; blr
	mtspr  525,r4; blr
	mfspr  r3,526; blr
	mtspr  526,r4; blr
	mfspr  r3,527; blr
	mtspr  527,r4; blr
	mfspr  r3,528; blr
	mtspr  528,r4; blr
	mfspr  r3,529; blr
	mtspr  529,r4; blr
	mfspr  r3,530; blr
	mtspr  530,r4; blr
	mfspr  r3,531; blr
	mtspr  531,r4; blr
	mfspr  r3,532; blr
	mtspr  532,r4; blr
	mfspr  r3,533; blr
	mtspr  533,r4; blr
	mfspr  r3,534; blr
	mtspr  534,r4; blr
	mfspr  r3,535; blr
	mtspr  535,r4; blr
	mfspr  r3,536; blr
	mtspr  536,r4; blr
	mfspr  r3,537; blr
	mtspr  537,r4; blr
	mfspr  r3,538; blr
	mtspr  538,r4; blr
	mfspr  r3,539; blr
	mtspr  539,r4; blr
	mfspr  r3,540; blr
	mtspr  540,r4; blr
	mfspr  r3,541; blr
	mtspr  541,r4; blr
	mfspr  r3,542; blr
	mtspr  542,r4; blr
	mfspr  r3,543; blr
	mtspr  543,r4; blr
	mfspr  r3,544; blr
	mtspr  544,r4; blr
	mfspr  r3,545; blr
	mtspr  545,r4; blr
	mfspr  r3,546; blr
	mtspr  546,r4; blr
	mfspr  r3,547; blr
	mtspr  547,r4; blr
	mfspr  r3,548; blr
	mtspr  548,r4; blr
	mfspr  r3,549; blr
	mtspr  549,r4; blr
	mfspr  r3,550; blr
	mtspr  550,r4; blr
	mfspr  r3,551; blr
	mtspr  551,r4; blr
	mfspr  r3,552; blr
	mtspr  552,r4; blr
	mfspr  r3,553; blr
	mtspr  553,r4; blr
	mfspr  r3,554; blr
	mtspr  554,r4; blr
	mfspr  r3,555; blr
	mtspr  555,r4; blr
	mfspr  r3,556; blr
	mtspr  556,r4; blr
	mfspr  r3,557; blr
	mtspr  557,r4; blr
	mfspr  r3,558; blr
	mtspr  558,r4; blr
	mfspr  r3,559; blr
	mtspr  559,r4; blr
	mfspr  r3,560; blr
	mtspr  560,r4; blr
	mfspr  r3,561; blr
	mtspr  561,r4; blr
	mfspr  r3,562; blr
	mtspr  562,r4; blr
	mfspr  r3,563; blr
	mtspr  563,r4; blr
	mfspr  r3,564; blr
	mtspr  564,r4; blr
	mfspr  r3,565; blr
	mtspr  565,r4; blr
	mfspr  r3,566; blr
	mtspr  566,r4; blr
	mfspr  r3,567; blr
	mtspr  567,r4; blr
	mfspr  r3,568; blr
	mtspr  568,r4; blr
	mfspr  r3,569; blr
	mtspr  569,r4; blr
	mfspr  r3,570; blr
	mtspr  570,r4; blr
	mfspr  r3,571; blr
	mtspr  571,r4; blr
	mfspr  r3,572; blr
	mtspr  572,r4; blr
	mfspr  r3,573; blr
	mtspr  573,r4; blr
	mfspr  r3,574; blr
	mtspr  574,r4; blr
	mfspr  r3,575; blr
	mtspr  575,r4; blr
	mfspr  r3,576; blr
	mtspr  576,r4; blr
	mfspr  r3,577; blr
	mtspr  577,r4; blr
	mfspr  r3,578; blr
	mtspr  578,r4; blr
	mfspr  r3,579; blr
	mtspr  579,r4; blr
	mfspr  r3,580; blr
	mtspr  580,r4; blr
	mfspr  r3,581; blr
	mtspr  581,r4; blr
	mfspr  r3,582; blr
	mtspr  582,r4; blr
	mfspr  r3,583; blr
	mtspr  583,r4; blr
	mfspr  r3,584; blr
	mtspr  584,r4; blr
	mfspr  r3,585; blr
	mtspr  585,r4; blr
	mfspr  r3,586; blr
	mtspr  586,r4; blr
	mfspr  r3,587; blr
	mtspr  587,r4; blr
	mfspr  r3,588; blr
	mtspr  588,r4; blr
	mfspr  r3,589; blr
	mtspr  589,r4; blr
	mfspr  r3,590; blr
	mtspr  590,r4; blr
	mfspr  r3,591; blr
	mtspr  591,r4; blr
	mfspr  r3,592; blr
	mtspr  592,r4; blr
	mfspr  r3,593; blr
	mtspr  593,r4; blr
	mfspr  r3,594; blr
	mtspr  594,r4; blr
	mfspr  r3,595; blr
	mtspr  595,r4; blr
	mfspr  r3,596; blr
	mtspr  596,r4; blr
	mfspr  r3,597; blr
	mtspr  597,r4; blr
	mfspr  r3,598; blr
	mtspr  598,r4; blr
	mfspr  r3,599; blr
	mtspr  599,r4; blr
	mfspr  r3,600; blr
	mtspr  600,r4; blr
	mfspr  r3,601; blr
	mtspr  601,r4; blr
	mfspr  r3,602; blr
	mtspr  602,r4; blr
	mfspr  r3,603; blr
	mtspr  603,r4; blr
	mfspr  r3,604; blr
	mtspr  604,r4; blr
	mfspr  r3,605; blr
	mtspr  605,r4; blr
	mfspr  r3,606; blr
	mtspr  606,r4; blr
	mfspr  r3,607; blr
	mtspr  607,r4; blr
	mfspr  r3,608; blr
	mtspr  608,r4; blr
	mfspr  r3,609; blr
	mtspr  609,r4; blr
	mfspr  r3,610; blr
	mtspr  610,r4; blr
	mfspr  r3,611; blr
	mtspr  611,r4; blr
	mfspr  r3,612; blr
	mtspr  612,r4; blr
	mfspr  r3,613; blr
	mtspr  613,r4; blr
	mfspr  r3,614; blr
	mtspr  614,r4; blr
	mfspr  r3,615; blr
	mtspr  615,r4; blr
	mfspr  r3,616; blr
	mtspr  616,r4; blr
	mfspr  r3,617; blr
	mtspr  617,r4; blr
	mfspr  r3,618; blr
	mtspr  618,r4; blr
	mfspr  r3,619; blr
	mtspr  619,r4; blr
	mfspr  r3,620; blr
	mtspr  620,r4; blr
	mfspr  r3,621; blr
	mtspr  621,r4; blr
	mfspr  r3,622; blr
	mtspr  622,r4; blr
	mfspr  r3,623; blr
	mtspr  623,r4; blr
	mfspr  r3,624; blr
	mtspr  624,r4; blr
	mfspr  r3,625; blr
	mtspr  625,r4; blr
	mfspr  r3,626; blr
	mtspr  626,r4; blr
	mfspr  r3,627; blr
	mtspr  627,r4; blr
	mfspr  r3,628; blr
	mtspr  628,r4; blr
	mfspr  r3,629; blr
	mtspr  629,r4; blr
	mfspr  r3,630; blr
	mtspr  630,r4; blr
	mfspr  r3,631; blr
	mtspr  631,r4; blr
	mfspr  r3,632; blr
	mtspr  632,r4; blr
	mfspr  r3,633; blr
	mtspr  633,r4; blr
	mfspr  r3,634; blr
	mtspr  634,r4; blr
	mfspr  r3,635; blr
	mtspr  635,r4; blr
	mfspr  r3,636; blr
	mtspr  636,r4; blr
	mfspr  r3,637; blr
	mtspr  637,r4; blr
	mfspr  r3,638; blr
	mtspr  638,r4; blr
	mfspr  r3,639; blr
	mtspr  639,r4; blr
	mfspr  r3,640; blr
	mtspr  640,r4; blr
	mfspr  r3,641; blr
	mtspr  641,r4; blr
	mfspr  r3,642; blr
	mtspr  642,r4; blr
	mfspr  r3,643; blr
	mtspr  643,r4; blr
	mfspr  r3,644; blr
	mtspr  644,r4; blr
	mfspr  r3,645; blr
	mtspr  645,r4; blr
	mfspr  r3,646; blr
	mtspr  646,r4; blr
	mfspr  r3,647; blr
	mtspr  647,r4; blr
	mfspr  r3,648; blr
	mtspr  648,r4; blr
	mfspr  r3,649; blr
	mtspr  649,r4; blr
	mfspr  r3,650; blr
	mtspr  650,r4; blr
	mfspr  r3,651; blr
	mtspr  651,r4; blr
	mfspr  r3,652; blr
	mtspr  652,r4; blr
	mfspr  r3,653; blr
	mtspr  653,r4; blr
	mfspr  r3,654; blr
	mtspr  654,r4; blr
	mfspr  r3,655; blr
	mtspr  655,r4; blr
	mfspr  r3,656; blr
	mtspr  656,r4; blr
	mfspr  r3,657; blr
	mtspr  657,r4; blr
	mfspr  r3,658; blr
	mtspr  658,r4; blr
	mfspr  r3,659; blr
	mtspr  659,r4; blr
	mfspr  r3,660; blr
	mtspr  660,r4; blr
	mfspr  r3,661; blr
	mtspr  661,r4; blr
	mfspr  r3,662; blr
	mtspr  662,r4; blr
	mfspr  r3,663; blr
	mtspr  663,r4; blr
	mfspr  r3,664; blr
	mtspr  664,r4; blr
	mfspr  r3,665; blr
	mtspr  665,r4; blr
	mfspr  r3,666; blr
	mtspr  666,r4; blr
	mfspr  r3,667; blr
	mtspr  667,r4; blr
	mfspr  r3,668; blr
	mtspr  668,r4; blr
	mfspr  r3,669; blr
	mtspr  669,r4; blr
	mfspr  r3,670; blr
	mtspr  670,r4; blr
	mfspr  r3,671; blr
	mtspr  671,r4; blr
	mfspr  r3,672; blr
	mtspr  672,r4; blr
	mfspr  r3,673; blr
	mtspr  673,r4; blr
	mfspr  r3,674; blr
	mtspr  674,r4; blr
	mfspr  r3,675; blr
	mtspr  675,r4; blr
	mfspr  r3,676; blr
	mtspr  676,r4; blr
	mfspr  r3,677; blr
	mtspr  677,r4; blr
	mfspr  r3,678; blr
	mtspr  678,r4; blr
	mfspr  r3,679; blr
	mtspr  679,r4; blr
	mfspr  r3,680; blr
	mtspr  680,r4; blr
	mfspr  r3,681; blr
	mtspr  681,r4; blr
	mfspr  r3,682; blr
	mtspr  682,r4; blr
	mfspr  r3,683; blr
	mtspr  683,r4; blr
	mfspr  r3,684; blr
	mtspr  684,r4; blr
	mfspr  r3,685; blr
	mtspr  685,r4; blr
	mfspr  r3,686; blr
	mtspr  686,r4; blr
	mfspr  r3,687; blr
	mtspr  687,r4; blr
	mfspr  r3,688; blr
	mtspr  688,r4; blr
	mfspr  r3,689; blr
	mtspr  689,r4; blr
	mfspr  r3,690; blr
	mtspr  690,r4; blr
	mfspr  r3,691; blr
	mtspr  691,r4; blr
	mfspr  r3,692; blr
	mtspr  692,r4; blr
	mfspr  r3,693; blr
	mtspr  693,r4; blr
	mfspr  r3,694; blr
	mtspr  694,r4; blr
	mfspr  r3,695; blr
	mtspr  695,r4; blr
	mfspr  r3,696; blr
	mtspr  696,r4; blr
	mfspr  r3,697; blr
	mtspr  697,r4; blr
	mfspr  r3,698; blr
	mtspr  698,r4; blr
	mfspr  r3,699; blr
	mtspr  699,r4; blr
	mfspr  r3,700; blr
	mtspr  700,r4; blr
	mfspr  r3,701; blr
	mtspr  701,r4; blr
	mfspr  r3,702; blr
	mtspr  702,r4; blr
	mfspr  r3,703; blr
	mtspr  703,r4; blr
	mfspr  r3,704; blr
	mtspr  704,r4; blr
	mfspr  r3,705; blr
	mtspr  705,r4; blr
	mfspr  r3,706; blr
	mtspr  706,r4; blr
	mfspr  r3,707; blr
	mtspr  707,r4; blr
	mfspr  r3,708; blr
	mtspr  708,r4; blr
	mfspr  r3,709; blr
	mtspr  709,r4; blr
	mfspr  r3,710; blr
	mtspr  710,r4; blr
	mfspr  r3,711; blr
	mtspr  711,r4; blr
	mfspr  r3,712; blr
	mtspr  712,r4; blr
	mfspr  r3,713; blr
	mtspr  713,r4; blr
	mfspr  r3,714; blr
	mtspr  714,r4; blr
	mfspr  r3,715; blr
	mtspr  715,r4; blr
	mfspr  r3,716; blr
	mtspr  716,r4; blr
	mfspr  r3,717; blr
	mtspr  717,r4; blr
	mfspr  r3,718; blr
	mtspr  718,r4; blr
	mfspr  r3,719; blr
	mtspr  719,r4; blr
	mfspr  r3,720; blr
	mtspr  720,r4; blr
	mfspr  r3,721; blr
	mtspr  721,r4; blr
	mfspr  r3,722; blr
	mtspr  722,r4; blr
	mfspr  r3,723; blr
	mtspr  723,r4; blr
	mfspr  r3,724; blr
	mtspr  724,r4; blr
	mfspr  r3,725; blr
	mtspr  725,r4; blr
	mfspr  r3,726; blr
	mtspr  726,r4; blr
	mfspr  r3,727; blr
	mtspr  727,r4; blr
	mfspr  r3,728; blr
	mtspr  728,r4; blr
	mfspr  r3,729; blr
	mtspr  729,r4; blr
	mfspr  r3,730; blr
	mtspr  730,r4; blr
	mfspr  r3,731; blr
	mtspr  731,r4; blr
	mfspr  r3,732; blr
	mtspr  732,r4; blr
	mfspr  r3,733; blr
	mtspr  733,r4; blr
	mfspr  r3,734; blr
	mtspr  734,r4; blr
	mfspr  r3,735; blr
	mtspr  735,r4; blr
	mfspr  r3,736; blr
	mtspr  736,r4; blr
	mfspr  r3,737; blr
	mtspr  737,r4; blr
	mfspr  r3,738; blr
	mtspr  738,r4; blr
	mfspr  r3,739; blr
	mtspr  739,r4; blr
	mfspr  r3,740; blr
	mtspr  740,r4; blr
	mfspr  r3,741; blr
	mtspr  741,r4; blr
	mfspr  r3,742; blr
	mtspr  742,r4; blr
	mfspr  r3,743; blr
	mtspr  743,r4; blr
	mfspr  r3,744; blr
	mtspr  744,r4; blr
	mfspr  r3,745; blr
	mtspr  745,r4; blr
	mfspr  r3,746; blr
	mtspr  746,r4; blr
	mfspr  r3,747; blr
	mtspr  747,r4; blr
	mfspr  r3,748; blr
	mtspr  748,r4; blr
	mfspr  r3,749; blr
	mtspr  749,r4; blr
	mfspr  r3,750; blr
	mtspr  750,r4; blr
	mfspr  r3,751; blr
	mtspr  751,r4; blr
	mfspr  r3,752; blr
	mtspr  752,r4; blr
	mfspr  r3,753; blr
	mtspr  753,r4; blr
	mfspr  r3,754; blr
	mtspr  754,r4; blr
	mfspr  r3,755; blr
	mtspr  755,r4; blr
	mfspr  r3,756; blr
	mtspr  756,r4; blr
	mfspr  r3,757; blr
	mtspr  757,r4; blr
	mfspr  r3,758; blr
	mtspr  758,r4; blr
	mfspr  r3,759; blr
	mtspr  759,r4; blr
	mfspr  r3,760; blr
	mtspr  760,r4; blr
	mfspr  r3,761; blr
	mtspr  761,r4; blr
	mfspr  r3,762; blr
	mtspr  762,r4; blr
	mfspr  r3,763; blr
	mtspr  763,r4; blr
	mfspr  r3,764; blr
	mtspr  764,r4; blr
	mfspr  r3,765; blr
	mtspr  765,r4; blr
	mfspr  r3,766; blr
	mtspr  766,r4; blr
	mfspr  r3,767; blr
	mtspr  767,r4; blr
	mfspr  r3,768; blr
	mtspr  768,r4; blr
	mfspr  r3,769; blr
	mtspr  769,r4; blr
	mfspr  r3,770; blr
	mtspr  770,r4; blr
	mfspr  r3,771; blr
	mtspr  771,r4; blr
	mfspr  r3,772; blr
	mtspr  772,r4; blr
	mfspr  r3,773; blr
	mtspr  773,r4; blr
	mfspr  r3,774; blr
	mtspr  774,r4; blr
	mfspr  r3,775; blr
	mtspr  775,r4; blr
	mfspr  r3,776; blr
	mtspr  776,r4; blr
	mfspr  r3,777; blr
	mtspr  777,r4; blr
	mfspr  r3,778; blr
	mtspr  778,r4; blr
	mfspr  r3,779; blr
	mtspr  779,r4; blr
	mfspr  r3,780; blr
	mtspr  780,r4; blr
	mfspr  r3,781; blr
	mtspr  781,r4; blr
	mfspr  r3,782; blr
	mtspr  782,r4; blr
	mfspr  r3,783; blr
	mtspr  783,r4; blr
	mfspr  r3,784; blr
	mtspr  784,r4; blr
	mfspr  r3,785; blr
	mtspr  785,r4; blr
	mfspr  r3,786; blr
	mtspr  786,r4; blr
	mfspr  r3,787; blr
	mtspr  787,r4; blr
	mfspr  r3,788; blr
	mtspr  788,r4; blr
	mfspr  r3,789; blr
	mtspr  789,r4; blr
	mfspr  r3,790; blr
	mtspr  790,r4; blr
	mfspr  r3,791; blr
	mtspr  791,r4; blr
	mfspr  r3,792; blr
	mtspr  792,r4; blr
	mfspr  r3,793; blr
	mtspr  793,r4; blr
	mfspr  r3,794; blr
	mtspr  794,r4; blr
	mfspr  r3,795; blr
	mtspr  795,r4; blr
	mfspr  r3,796; blr
	mtspr  796,r4; blr
	mfspr  r3,797; blr
	mtspr  797,r4; blr
	mfspr  r3,798; blr
	mtspr  798,r4; blr
	mfspr  r3,799; blr
	mtspr  799,r4; blr
	mfspr  r3,800; blr
	mtspr  800,r4; blr
	mfspr  r3,801; blr
	mtspr  801,r4; blr
	mfspr  r3,802; blr
	mtspr  802,r4; blr
	mfspr  r3,803; blr
	mtspr  803,r4; blr
	mfspr  r3,804; blr
	mtspr  804,r4; blr
	mfspr  r3,805; blr
	mtspr  805,r4; blr
	mfspr  r3,806; blr
	mtspr  806,r4; blr
	mfspr  r3,807; blr
	mtspr  807,r4; blr
	mfspr  r3,808; blr
	mtspr  808,r4; blr
	mfspr  r3,809; blr
	mtspr  809,r4; blr
	mfspr  r3,810; blr
	mtspr  810,r4; blr
	mfspr  r3,811; blr
	mtspr  811,r4; blr
	mfspr  r3,812; blr
	mtspr  812,r4; blr
	mfspr  r3,813; blr
	mtspr  813,r4; blr
	mfspr  r3,814; blr
	mtspr  814,r4; blr
	mfspr  r3,815; blr
	mtspr  815,r4; blr
	mfspr  r3,816; blr
	mtspr  816,r4; blr
	mfspr  r3,817; blr
	mtspr  817,r4; blr
	mfspr  r3,818; blr
	mtspr  818,r4; blr
	mfspr  r3,819; blr
	mtspr  819,r4; blr
	mfspr  r3,820; blr
	mtspr  820,r4; blr
	mfspr  r3,821; blr
	mtspr  821,r4; blr
	mfspr  r3,822; blr
	mtspr  822,r4; blr
	mfspr  r3,823; blr
	mtspr  823,r4; blr
	mfspr  r3,824; blr
	mtspr  824,r4; blr
	mfspr  r3,825; blr
	mtspr  825,r4; blr
	mfspr  r3,826; blr
	mtspr  826,r4; blr
	mfspr  r3,827; blr
	mtspr  827,r4; blr
	mfspr  r3,828; blr
	mtspr  828,r4; blr
	mfspr  r3,829; blr
	mtspr  829,r4; blr
	mfspr  r3,830; blr
	mtspr  830,r4; blr
	mfspr  r3,831; blr
	mtspr  831,r4; blr
	mfspr  r3,832; blr
	mtspr  832,r4; blr
	mfspr  r3,833; blr
	mtspr  833,r4; blr
	mfspr  r3,834; blr
	mtspr  834,r4; blr
	mfspr  r3,835; blr
	mtspr  835,r4; blr
	mfspr  r3,836; blr
	mtspr  836,r4; blr
	mfspr  r3,837; blr
	mtspr  837,r4; blr
	mfspr  r3,838; blr
	mtspr  838,r4; blr
	mfspr  r3,839; blr
	mtspr  839,r4; blr
	mfspr  r3,840; blr
	mtspr  840,r4; blr
	mfspr  r3,841; blr
	mtspr  841,r4; blr
	mfspr  r3,842; blr
	mtspr  842,r4; blr
	mfspr  r3,843; blr
	mtspr  843,r4; blr
	mfspr  r3,844; blr
	mtspr  844,r4; blr
	mfspr  r3,845; blr
	mtspr  845,r4; blr
	mfspr  r3,846; blr
	mtspr  846,r4; blr
	mfspr  r3,847; blr
	mtspr  847,r4; blr
	mfspr  r3,848; blr
	mtspr  848,r4; blr
	mfspr  r3,849; blr
	mtspr  849,r4; blr
	mfspr  r3,850; blr
	mtspr  850,r4; blr
	mfspr  r3,851; blr
	mtspr  851,r4; blr
	mfspr  r3,852; blr
	mtspr  852,r4; blr
	mfspr  r3,853; blr
	mtspr  853,r4; blr
	mfspr  r3,854; blr
	mtspr  854,r4; blr
	mfspr  r3,855; blr
	mtspr  855,r4; blr
	mfspr  r3,856; blr
	mtspr  856,r4; blr
	mfspr  r3,857; blr
	mtspr  857,r4; blr
	mfspr  r3,858; blr
	mtspr  858,r4; blr
	mfspr  r3,859; blr
	mtspr  859,r4; blr
	mfspr  r3,860; blr
	mtspr  860,r4; blr
	mfspr  r3,861; blr
	mtspr  861,r4; blr
	mfspr  r3,862; blr
	mtspr  862,r4; blr
	mfspr  r3,863; blr
	mtspr  863,r4; blr
	mfspr  r3,864; blr
	mtspr  864,r4; blr
	mfspr  r3,865; blr
	mtspr  865,r4; blr
	mfspr  r3,866; blr
	mtspr  866,r4; blr
	mfspr  r3,867; blr
	mtspr  867,r4; blr
	mfspr  r3,868; blr
	mtspr  868,r4; blr
	mfspr  r3,869; blr
	mtspr  869,r4; blr
	mfspr  r3,870; blr
	mtspr  870,r4; blr
	mfspr  r3,871; blr
	mtspr  871,r4; blr
	mfspr  r3,872; blr
	mtspr  872,r4; blr
	mfspr  r3,873; blr
	mtspr  873,r4; blr
	mfspr  r3,874; blr
	mtspr  874,r4; blr
	mfspr  r3,875; blr
	mtspr  875,r4; blr
	mfspr  r3,876; blr
	mtspr  876,r4; blr
	mfspr  r3,877; blr
	mtspr  877,r4; blr
	mfspr  r3,878; blr
	mtspr  878,r4; blr
	mfspr  r3,879; blr
	mtspr  879,r4; blr
	mfspr  r3,880; blr
	mtspr  880,r4; blr
	mfspr  r3,881; blr
	mtspr  881,r4; blr
	mfspr  r3,882; blr
	mtspr  882,r4; blr
	mfspr  r3,883; blr
	mtspr  883,r4; blr
	mfspr  r3,884; blr
	mtspr  884,r4; blr
	mfspr  r3,885; blr
	mtspr  885,r4; blr
	mfspr  r3,886; blr
	mtspr  886,r4; blr
	mfspr  r3,887; blr
	mtspr  887,r4; blr
	mfspr  r3,888; blr
	mtspr  888,r4; blr
	mfspr  r3,889; blr
	mtspr  889,r4; blr
	mfspr  r3,890; blr
	mtspr  890,r4; blr
	mfspr  r3,891; blr
	mtspr  891,r4; blr
	mfspr  r3,892; blr
	mtspr  892,r4; blr
	mfspr  r3,893; blr
	mtspr  893,r4; blr
	mfspr  r3,894; blr
	mtspr  894,r4; blr
	mfspr  r3,895; blr
	mtspr  895,r4; blr
	mfspr  r3,896; blr
	mtspr  896,r4; blr
	mfspr  r3,897; blr
	mtspr  897,r4; blr
	mfspr  r3,898; blr
	mtspr  898,r4; blr
	mfspr  r3,899; blr
	mtspr  899,r4; blr
	mfspr  r3,900; blr
	mtspr  900,r4; blr
	mfspr  r3,901; blr
	mtspr  901,r4; blr
	mfspr  r3,902; blr
	mtspr  902,r4; blr
	mfspr  r3,903; blr
	mtspr  903,r4; blr
	mfspr  r3,904; blr
	mtspr  904,r4; blr
	mfspr  r3,905; blr
	mtspr  905,r4; blr
	mfspr  r3,906; blr
	mtspr  906,r4; blr
	mfspr  r3,907; blr
	mtspr  907,r4; blr
	mfspr  r3,908; blr
	mtspr  908,r4; blr
	mfspr  r3,909; blr
	mtspr  909,r4; blr
	mfspr  r3,910; blr
	mtspr  910,r4; blr
	mfspr  r3,911; blr
	mtspr  911,r4; blr
	mfspr  r3,912; blr
	mtspr  912,r4; blr
	mfspr  r3,913; blr
	mtspr  913,r4; blr
	mfspr  r3,914; blr
	mtspr  914,r4; blr
	mfspr  r3,915; blr
	mtspr  915,r4; blr
	mfspr  r3,916; blr
	mtspr  916,r4; blr
	mfspr  r3,917; blr
	mtspr  917,r4; blr
	mfspr  r3,918; blr
	mtspr  918,r4; blr
	mfspr  r3,919; blr
	mtspr  919,r4; blr
	mfspr  r3,920; blr
	mtspr  920,r4; blr
	mfspr  r3,921; blr
	mtspr  921,r4; blr
	mfspr  r3,922; blr
	mtspr  922,r4; blr
	mfspr  r3,923; blr
	mtspr  923,r4; blr
	mfspr  r3,924; blr
	mtspr  924,r4; blr
	mfspr  r3,925; blr
	mtspr  925,r4; blr
	mfspr  r3,926; blr
	mtspr  926,r4; blr
	mfspr  r3,927; blr
	mtspr  927,r4; blr
	mfspr  r3,928; blr
	mtspr  928,r4; blr
	mfspr  r3,929; blr
	mtspr  929,r4; blr
	mfspr  r3,930; blr
	mtspr  930,r4; blr
	mfspr  r3,931; blr
	mtspr  931,r4; blr
	mfspr  r3,932; blr
	mtspr  932,r4; blr
	mfspr  r3,933; blr
	mtspr  933,r4; blr
	mfspr  r3,934; blr
	mtspr  934,r4; blr
	mfspr  r3,935; blr
	mtspr  935,r4; blr
	mfspr  r3,936; blr
	mtspr  936,r4; blr
	mfspr  r3,937; blr
	mtspr  937,r4; blr
	mfspr  r3,938; blr
	mtspr  938,r4; blr
	mfspr  r3,939; blr
	mtspr  939,r4; blr
	mfspr  r3,940; blr
	mtspr  940,r4; blr
	mfspr  r3,941; blr
	mtspr  941,r4; blr
	mfspr  r3,942; blr
	mtspr  942,r4; blr
	mfspr  r3,943; blr
	mtspr  943,r4; blr
	mfspr  r3,944; blr
	mtspr  944,r4; blr
	mfspr  r3,945; blr
	mtspr  945,r4; blr
	mfspr  r3,946; blr
	mtspr  946,r4; blr
	mfspr  r3,947; blr
	mtspr  947,r4; blr
	mfspr  r3,948; blr
	mtspr  948,r4; blr
	mfspr  r3,949; blr
	mtspr  949,r4; blr
	mfspr  r3,950; blr
	mtspr  950,r4; blr
	mfspr  r3,951; blr
	mtspr  951,r4; blr
	mfspr  r3,952; blr
	mtspr  952,r4; blr
	mfspr  r3,953; blr
	mtspr  953,r4; blr
	mfspr  r3,954; blr
	mtspr  954,r4; blr
	mfspr  r3,955; blr
	mtspr  955,r4; blr
	mfspr  r3,956; blr
	mtspr  956,r4; blr
	mfspr  r3,957; blr
	mtspr  957,r4; blr
	mfspr  r3,958; blr
	mtspr  958,r4; blr
	mfspr  r3,959; blr
	mtspr  959,r4; blr
	mfspr  r3,960; blr
	mtspr  960,r4; blr
	mfspr  r3,961; blr
	mtspr  961,r4; blr
	mfspr  r3,962; blr
	mtspr  962,r4; blr
	mfspr  r3,963; blr
	mtspr  963,r4; blr
	mfspr  r3,964; blr
	mtspr  964,r4; blr
	mfspr  r3,965; blr
	mtspr  965,r4; blr
	mfspr  r3,966; blr
	mtspr  966,r4; blr
	mfspr  r3,967; blr
	mtspr  967,r4; blr
	mfspr  r3,968; blr
	mtspr  968,r4; blr
	mfspr  r3,969; blr
	mtspr  969,r4; blr
	mfspr  r3,970; blr
	mtspr  970,r4; blr
	mfspr  r3,971; blr
	mtspr  971,r4; blr
	mfspr  r3,972; blr
	mtspr  972,r4; blr
	mfspr  r3,973; blr
	mtspr  973,r4; blr
	mfspr  r3,974; blr
	mtspr  974,r4; blr
	mfspr  r3,975; blr
	mtspr  975,r4; blr
	mfspr  r3,976; blr
	mtspr  976,r4; blr
	mfspr  r3,977; blr
	mtspr  977,r4; blr
	mfspr  r3,978; blr
	mtspr  978,r4; blr
	mfspr  r3,979; blr
	mtspr  979,r4; blr
	mfspr  r3,980; blr
	mtspr  980,r4; blr
	mfspr  r3,981; blr
	mtspr  981,r4; blr
	mfspr  r3,982; blr
	mtspr  982,r4; blr
	mfspr  r3,983; blr
	mtspr  983,r4; blr
	mfspr  r3,984; blr
	mtspr  984,r4; blr
	mfspr  r3,985; blr
	mtspr  985,r4; blr
	mfspr  r3,986; blr
	mtspr  986,r4; blr
	mfspr  r3,987; blr
	mtspr  987,r4; blr
	mfspr  r3,988; blr
	mtspr  988,r4; blr
	mfspr  r3,989; blr
	mtspr  989,r4; blr
	mfspr  r3,990; blr
	mtspr  990,r4; blr
	mfspr  r3,991; blr
	mtspr  991,r4; blr
	mfspr  r3,992; blr
	mtspr  992,r4; blr
	mfspr  r3,993; blr
	mtspr  993,r4; blr
	mfspr  r3,994; blr
	mtspr  994,r4; blr
	mfspr  r3,995; blr
	mtspr  995,r4; blr
	mfspr  r3,996; blr
	mtspr  996,r4; blr
	mfspr  r3,997; blr
	mtspr  997,r4; blr
	mfspr  r3,998; blr
	mtspr  998,r4; blr
	mfspr  r3,999; blr
	mtspr  999,r4; blr
	mfspr  r3,1000; blr
	mtspr  1000,r4; blr
	mfspr  r3,1001; blr
	mtspr  1001,r4; blr
	mfspr  r3,1002; blr
	mtspr  1002,r4; blr
	mfspr  r3,1003; blr
	mtspr  1003,r4; blr
	mfspr  r3,1004; blr
	mtspr  1004,r4; blr
	mfspr  r3,1005; blr
	mtspr  1005,r4; blr
	mfspr  r3,1006; blr
	mtspr  1006,r4; blr
	mfspr  r3,1007; blr
	mtspr  1007,r4; blr
	mfspr  r3,1008; blr
	mtspr  1008,r4; blr
	mfspr  r3,1009; blr
	mtspr  1009,r4; blr
	mfspr  r3,1010; blr
	mtspr  1010,r4; blr
	mfspr  r3,1011; blr
	mtspr  1011,r4; blr
	mfspr  r3,1012; blr
	mtspr  1012,r4; blr
	mfspr  r3,1013; blr
	mtspr  1013,r4; blr
	mfspr  r3,1014; blr
	mtspr  1014,r4; blr
	mfspr  r3,1015; blr
	mtspr  1015,r4; blr
	mfspr  r3,1016; blr
	mtspr  1016,r4; blr
	mfspr  r3,1017; blr
	mtspr  1017,r4; blr
	mfspr  r3,1018; blr
	mtspr  1018,r4; blr
	mfspr  r3,1019; blr
	mtspr  1019,r4; blr
	mfspr  r3,1020; blr
	mtspr  1020,r4; blr
	mfspr  r3,1021; blr
	mtspr  1021,r4; blr
	mfspr  r3,1022; blr
	mtspr  1022,r4; blr
	mfspr  r3,1023; blr
	mtspr  1023,r4; blr
