/*
 * arch/ppc/platforms/frx_genri.h
 *
 *  FRX GENRI-board specific routines
 *
 *  Copyright 2003,2004 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __FRX_GENRI_H__
#define __FRX_GENRI_H__

#define PROC_CPUINFO_BOARD	"FRX-Genri"

/*
 * FRX IRQ triggering/polarity settings
 */
static u_char frx_genri_IRQ_initsenses[] __initdata = {
	UIC0_INITSENSE
	UIC1_INITSENSE
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 64: GPIO/ExtInt 0 */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 65: GPIO/ExtInt 1 */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 66: GPIO/ExtInt 2 */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 67: GPIO/ExtInt 3 */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 68: GPIO/ExtInt 4 */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 69: GPIO/ExtInt 5 */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 70: GPIO/ExtInt 6 */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 71: GPIO/ExtInt 7 */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 72: GPIO/ExtInt 8 */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 73: GPIO/ExtInt 9 */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 74: GPIO/ExtInt 10 */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 75: GPIO/ExtInt 11 */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 76: GPIO/ExtInt 12 */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 77: GPIO/ExtInt 13 (VDEC_XINT) */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 78: GPIO/ExtInt 14 (HDMI_XINT) */
  (IBM4xx_IRQ_SNS_EDG | IBM4xx_IRQ_POL_POS),	/* 79: GPIO/ExtInt 15 (DV_HST_INT) */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 80: GPIO/ExtInt 16 (MS_LED) */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 81: GPIO/ExtInt 17 (MS_PWR_ON) */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 82: GPIO/ExtInt 18 (CPU_DBG_LED) */
  (IBM4xx_IRQ_SNS_EDG | IBM4xx_IRQ_POL_NEG),	/* 83: GPIO/ExtInt 19 (NNMI) */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 84: ExtInt 20 (APX_XINT0#) */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 85: ExtInt 21 (APX_XINT1#) */
  (IBM4xx_IRQ_SNS_EDG | IBM4xx_IRQ_POL_NEG),	/* 86: ExtInt 22 (VBI_XINT) */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 87: ExtInt 23 (APX_XINT2) */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 88: ExtInt 24 (FLASH_BSY#) */
  (IBM4xx_IRQ_SNS_EDG | IBM4xx_IRQ_POL_POS),	/* 89: ExtInt 25 (DV_SYNC_INT) */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 90: MS Pro Insert Detect */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_NEG),	/* 91: MS Pro Core Int */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_POS),	/* 92: Reserved */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_POS),	/* 93: Reserved */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_POS),	/* 94: Reserved */
  (IBM4xx_IRQ_SNS_LVL | IBM4xx_IRQ_POL_POS),	/* 95: Reserved */
};

#ifdef CONFIG_CXD4707_ES_2_0

/* INT routing to Slot 0: Device 0. */
#define PCI_INT_A 41
#define PCI_INT_B 42
#define PCI_INT_C 43
#define PCI_INT_D 40
static char pci_irq_table[4] = {PCI_INT_A, PCI_INT_B, PCI_INT_C, PCI_INT_D};
static inline int
frx_genri_map_irq(struct pci_dev *dev, unsigned char idsel, unsigned char pin)
{
	return pci_irq_table[(idsel + pin - 1) % 4];
}

#else  /* !CONFIG_CXD4707_ES_2_0 */
static inline int
frx_genri_map_irq(struct pci_dev *dev, unsigned char idsel, unsigned char pin)
{
	static char pci_irq_table[][4] =
	/*
	 *	PCI IDSEL/INTPIN->INTLINE 
	 * 	   A   B   C   D
	 */
	{
		{ 40, 41, 42, 43 }, /* IDSEL 11 */
		{ 41, 42, 43, 40 },
		{ 42, 43, 40, 41 },
		{ 43, 40, 41, 42 },
		{ 40, 41, 42, 43 },
		{ 41, 42, 43, 40 },
		{ 42, 43, 40, 41 },
		{ 43, 40, 41, 42 },
		{ 40, 41, 42, 43 },
		{ 41, 42, 43, 40 },
		{ 42, 43, 40, 41 },
		{ 43, 40, 41, 42 },
		{ 40, 41, 42, 43 },
		{ 41, 42, 43, 40 }, /* IDSEL 24 */
		{ 42, 43, 40, 41 },
		{ 43, 40, 41, 42 },
		{ 40, 41, 42, 43 },
		{ 41, 42, 43, 40 }, /* IDSEL 28 */
	};
	const long min_idsel = 1, max_idsel = 18, irqs_per_slot = 4;
	return PCI_IRQ_TABLE_LOOKUP;
}
#endif /* !CONFIG_CXD4707_ES_2_0 */


#endif /* !__FRX_GENRI_H__ */
