/*
 *  Target specific definitions for CXD9790GG for Kaiser
 *
 *  Copyright 2003 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _KAISER_CXD9790_H
#define _KAISER_CXD9790_H

#error "kaiser_cxd9790.h is deprecated. use mpu4xx_cxd9790.h"

#if 0

/* base virtual address */
extern void *kaiser_cxd9790_base_vaddr;
#define KAISER_CXD9790_BASE ((u8 *)kaiser_cxd9790_base_vaddr)

/* access macros */
#define CXD9790_READ(addr)		readb(KAISER_CXD9790_BASE + (addr))
#define CXD9790_WRITE(addr, val)	writeb(val, KAISER_CXD9790_BASE + (addr))

/* IRQ definition */
/* define number of board specific IRQ */

#define CXD9790_IRQ_OFFSET	64 /* PPC440GP UIC IRQ at 0-63 */
#define CXD9790_IRQ_DEPTH	1

#ifdef CONFIG_SNSC_CXD9790_UART
#include <linux/cxd9790.h>

#define STD_COM_FLAGS (ASYNC_BOOT_AUTOCONF | ASYNC_SKIP_TEST)

#define KAISER_CXD9790_BASE_BAUD	(24000000 / 16)
#define KAISER_CXD9790_UART_OP \
	{ baud_base: KAISER_CXD9790_BASE_BAUD, \
	  irq: CXD9790_IRQ_UART0, \
	  io_type: SERIAL_IO_MEM, \
	  flags: STD_COM_FLAGS, \
	  type: PORT_16550A }, \
	{ baud_base: KAISER_CXD9790_BASE_BAUD, \
	  irq: CXD9790_IRQ_UART1, \
	  io_type: SERIAL_IO_MEM, \
	  flags: STD_COM_FLAGS, \
	  type: PORT_16550A }, \
	{ baud_base: KAISER_CXD9790_BASE_BAUD, \
	  irq: CXD9790_IRQ_UART2, \
	  io_type: SERIAL_IO_MEM, \
	  flags: STD_COM_FLAGS, \
	  type: PORT_16550A }, \
	{ baud_base: KAISER_CXD9790_BASE_BAUD, \
	  irq: CXD9790_IRQ_UART3, \
	  io_type: SERIAL_IO_MEM, \
	  flags: STD_COM_FLAGS, \
	  type: PORT_16550A },
#else  /* CONFIG_SNSC_CXD9790_UART */
#define KAISER_CXD9790_UART_OP
#endif /* !CONFIG_SNSC_CXD9790_UART */

#endif

#endif /* _KAISER_CXD9790_H */
