/*
 *  Kaiser specific definition for RTC7301
 *
 *  Copyright 2003 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __KAISER_RTC7301H__
#define __KAISER_RTC7301_H__

#include <linux/config.h>
#include "kaiser.h"

#include <linux/cxd9790.h>
#include <linux/cxd9790_gpio.h>

/* RTC7301 base virtual address */
extern void *ppc_rtc7301_base_vaddr;
#define PPC_RTC7301_BASE_VADDR	(ppc_rtc7301_base_vaddr)

#define RTC7301_PADDR		KAISER_RTC_ADDR
#define RTC7301_SIZE		KAISER_RTC_SIZE
#define PPC_RTC7301_IRQ_NUM	CXD9790_IRQ_GPIOA(2)

static inline void
ppc_rtc7301_init(void)
{
	ppc_rtc7301_base_vaddr = ioremap64(RTC7301_PADDR, RTC7301_SIZE);
	if (ppc_rtc7301_base_vaddr == NULL) {
		printk(KERN_ERR "%s(): ioremap64() failed.", __FUNCTION__);
		return ;
	}
	printk("RTC7301: ioremap64()\n");
	return;
}

#endif /* __KAISER_RTC7301_H__ */

