/*
 *  cryptowrap-aes.c - glue for RAND function of CryptoAPI
 *
 *  Copyright 2003 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <linux/module.h>
#include <linux/version.h>

#include <linux/init.h>
#include <linux/config.h>
#include <linux/string.h>
#include <linux/crypto.h>

#include <linux/cryptowrap.h>

/*
 *  CryptoWrap for DES in CryptoAPI
 */

void
CryptoWrap_RAND(void *buf, int size)
{
	get_random_bytes(buf, size);
	return;
}

/* module */
static int CryptoWrap_RAND_module_init(void);
static void CryptoWrap_RAND_module_exit(void);

static int
CryptoWrap_RAND_module_init()
{
	printk(KERN_INFO "CryptoWrap_RAND: loaded\n");
	return 0;
}

static void
CryptoWrap_RAND_module_exit()
{
	printk(KERN_INFO "CryptoWrap_RAND: unloaded\n");
}

module_init(CryptoWrap_RAND_module_init);
module_exit(CryptoWrap_RAND_module_exit);

EXPORT_SYMBOL(CryptoWrap_RAND);
