/*
 *  i2c-cxd.h
 *
 *  i2c algorithm  for SONY_LSI I2C IP
 *
 *  Copyright 2001-2003 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */  
  
#include <linux/module.h>
#ifndef _I2C_CXD_H
#define _I2C_CXD_H
#define CXD_ICDA 		0x00
#define CXD_ICAR 		0x00
#define CXD_ICARH 		0x01
#define CXD_ICCS 		0x02
#define CXD_ICCM 		0x03
#define CXD_ICCCL 		0x04
#define CXD_ICCCH 		0x05
#define CXD_ICATMC 		0x06
#define CXD_ICTCR 		0x07
#define CXD_ICATMS 		0x08
#define CXD_ICDS 		0x09
#define CXD_ICINT 		0x0A
#define CXD_ICINTC 		0x0B
#define CXD_ICTCTL 		0x0C
#define CXD_ICTIN 		0x0D
#define CXD_ICTOUT 		0x0E
#define CXD_SRAM                0xFE
  
#define CXD_ICINTC_INTI2CSC  (1<<2)
#define CXD_ICINTC_INTATMC   (1<<1)
#define CXD_ICINTC_INTI2CC   (1<<0)
  
#define CXD_ICINT_ATMEN      (1<<5)
#define CXD_ICINT_INTATM     (1<<1)
  
#define CXD_ICCS_BB          (1<<5)
  
#define CXD_ICCM_ACK         (1<<7)
#define CXD_ICCM_ATM         (1<<2)
#define CXD_ICCM_SDA         (1<<1)
#define CXD_ICCM_SCL         (1<<0)
  
#define CXD_ICATMC_AT0       (1<<0)
#define CXD_ICATMC_AT1       (1<<1)
#define CXD_ICATMC_APC       (1<<2)
#define CXD_ICATMC_EXT       (1<<4)
#define CXD_ICATMC_ERRST     (1<<6)
#define CXD_ICATMC_IRST      (1<<7)
  
#define I2C_PROTCOL_READ    (1<<0)
  struct i2c_algo_cxd_data
{
  void *data;			/* private data for lolevel routines    */
   void (*setiic) (void *data, int ctl, short val);
   int (*getiic) (void *data, int ctl);
   int (*getown) (void *data);
   int (*getclock) (void *data);
   void (*waitforpin) (void *data);
   
    /* local settings */ 
  int udelay;
   int mdelay;
   int timeout;
 };
int i2c_cxd_add_bus (struct i2c_adapter *);
int i2c_cxd_del_bus (struct i2c_adapter *);

#endif	
