/*
 *  i2c-dbmx1.h
 *
 *  i2c algorithm & adapter for MPU110
 *
 *  Copyright 2001-2003 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <linux/module.h>
#ifndef _I2C_DBMX1_H
#define _I2C_DBMX1_H
#define DEF_FREQ 		0x17
#define I2C_DBMX1_REG_ADDR 	(0x00217000 + 0x00000000)
#define MPU110_EEPROM_ADDR 0xa0

#define I2C_DBMX1_CHANGE_FREQ 	0xaa
#define I2C_DBMX1_GET_STATUS 	0xab

#define I2C_PROTCOL_READ (1<<0)

#define I2C_DBMX1_I2CR_RSTA (1<<2)
#define I2C_DBMX1_I2CR_TXAK (1<<3)
#define I2C_DBMX1_I2CR_MTX (1<<4)
#define I2C_DBMX1_I2CR_MSTA (1<<5)
#define I2C_DBMX1_I2CR_IIEN (1<<6)
#define I2C_DBMX1_I2CR_IEN (1<<7)

#define I2C_DBMX1_I2SR_RXAK (1<<0)
#define I2C_DBMX1_I2SR_IIF (1<<1)
#define I2C_DBMX1_I2SR_SRW (1<<2)
#define I2C_DBMX1_I2SR_IAL (1<<4)
#define I2C_DBMX1_I2SR_IBB (1<<5)
#define I2C_DBMX1_I2SR_IAAS (1<<6)
#define I2C_DBMX1_I2SR_ICF (1<<7)

#define I2C_DBMX1_IADR			0x00217000
#define I2C_DBMX1_IFDR			0x00217004
#define I2C_DBMX1_I2CR			0x00217008
#define I2C_DBMX1_I2SR			0x0021700c
#define I2C_DBMX1_I2DR			0x00217010

#endif 	
