/*
 *  ioa_3_eth.h
 *
 *  SMC91111 setup code for IOA-3
 *
 *  Copyright 2003 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _IOA_3_ETH_H_
#define _IOA_3_ETH_H_

#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include "mpu110_series_eth.h"

extern int ioa_3_eth_intnum(void);
extern int ioa_3_eth_baseaddr(void);
extern int ioa_3_eth_check_disable(void);
extern int ioa_3_eth_setup(void);
extern int ioa_3_eth_request_irq(unsigned int irq, 
				 void (*handler)(int, void *, struct pt_regs *),
				 unsigned long irq_flags, const char * devname, 
				 void *dev_id);
extern int ioa_3_eth_free_irq(unsigned int irq, void *dev_id);
extern int ioa_3_eth_clear_intr(void *dev_id);

extern mpu110_series_eth_ops_t ioa_3_eth;

#endif /* _IOA_3_ETH_H_ */
