/*
 * NBL boot config driver SDMWL version
 *
 * $Id: nblcfg_sdmwl.h,v 1.1 2004/04/28 17:47:54 satoru-i Exp $
 */
/* With non GPL files, use following license */
/*
 * Copyright 2001-2004 Sony Corporation.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
/* Otherwise with GPL files, use following license */
/*
 * Copyright 2001-2004 Sony Corporation.
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General  Public License as published by the
 * Free Software Foundation;  either version 2 of the  License.
 *
 * THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 * WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 * NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 * USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * You should have received a copy of the  GNU General Public License along
 * with this program; if not, write  to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __NBLCFG_SDMWL_H__
#define	__NBLCFG_SDMWL_H__

#define INFO(args...)  printk(KERN_INFO args)
#define ERROR(args...) printk(KERN_WARNING args)

#define NBLCFG_SDMPART           "nblconfig"

#ifdef CONFIG_NBLCONFIG_CHUNK_SIZE
#define NBLCONFIG_CHUNK_SIZE  CONFIG_NBLCONFIG_CHUNK_SIZE
#else
#define NBLCONFIG_CHUNK_SIZE  0x1000
#endif

#define NBLCONFIG_SIZE        128

#define NBLCONFIG_MAGIC  ((u_int16_t)'N' + 'C' * 256)

struct nblcfg_data {
	u_int16_t magic;
	u_int8_t  _rsvd[4 - sizeof(u_int16_t)];
	u_int8_t  boot_stat;
	u_int8_t  kern_sel;
	u_int8_t  retry;
	u_int8_t  _rsvd2[NBLCONFIG_SIZE - 
			(0x4 + sizeof(u_int8_t) * 3 + sizeof(u_int16_t) * 2)];
	u_int16_t color;
	u_int16_t cksum;
	u_int8_t  _padding[NBLCONFIG_CHUNK_SIZE - NBLCONFIG_SIZE];
};

#endif	/* __NBLCFG_SDMWL_H__ */
