/*
 * include/asm-ppc/cxd4707.h
 *
 *  Definitions for AVPPC with PPC440 core.
 *
 *  Copyright 2003,2004 Sony Corporation.
 *
 *  Copyright 2002 MontaVista Software Inc.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifdef __KERNEL__
#ifndef __ASM_CXD4707_H__
#define __ASM_CXD4707_H__

#include <linux/config.h>
#include <platforms/ibm440.h>


/*
 * DCRN definitions
 */ 
/* Base DCRNs */
#define DCRN_DMA4_BASE		0x140
#define DCRN_DMA5_BASE		0x148
#define DCRN_DMA6_BASE		0x150
#define DCRN_DMA7_BASE		0x158
#define DCRN_DMASR1_BASE	0x160

/* 
 * UIC 
 */
#define DCRN_UIC2_BASE	0xe0
#define UIC2		DCRN_UIC2_BASE

#define UIC0_UIC2NC      28	/* UIC2 non-critical interrupt */
#define UIC0_UIC2CR      29	/* UIC2 critical interrupt */

/* 
 * PCI Bridge
 */
#define PCI_REG_BASE	0xDF400000
#define PCI_REG_SIZE	0x40

#define PCI_PMM0LA 	0xDF400000	/* Local Address  */
#define PCI_PMM0MA	0xDF400004	/* Mask/Attribute  */
#define PCI_PMM0PCILA 	0xDF400008	/* PCI Low Address  */
#define PCI_PMM0PCIHA 	0xDF40000C	/* PCI High Address  */
#define PCI_PMM1LA  	0xDF400010
#define PCI_PMM1MA  	0xDF400014
#define PCI_PMM1PCILA  	0xDF400018
#define PCI_PMM1PCIHA  	0xDF40001C
#define PCI_PMM2LA  	0xDF400020
#define PCI_PMM2MA  	0xDF400024
#define PCI_PMM2PCILA  	0xDF400028
#define PCI_PMM2PCIHA  	0xDF40002C
#define PCI_PTM1MS 	0xDF400030	/* Memory Size/Attribute  */
#define PCI_PTM1LA 	0xDF400034	/* Local Address Register  */
#define PCI_PTM2MS  	0xDF400038
#define PCI_PTM2LA  	0xDF40003C

#define PCICFG_ADR 	0xDEC00000 	/* PCI Configuration Address  */
#define PCICFG_DATA 	0xDEC00004 	/* PCI Configuration Data  */

#endif /* __ASM_CXD4707_H__ */
#endif /* __KERNEL__ */
