/*
 *  Sony NSC NBLArgs architecture difinition
 *
 *  Copyright 2001-2003 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef __ARCH_NBLARGS_H__
#define __ARCH_NBLARGS_H__

#include <linux/autoconf.h>

/* handy sizes */
#define SZ_1K                           0x00000400
#define SZ_4K                           0x00001000
#define SZ_8K                           0x00002000
#define SZ_16K                          0x00004000
#define SZ_64K                          0x00010000
#define SZ_128K                         0x00020000
#define SZ_256K                         0x00040000
#define SZ_512K                         0x00080000

#define SZ_1M                           0x00100000
#define SZ_2M                           0x00200000
#define SZ_4M                           0x00400000
#define SZ_8M                           0x00800000
#define SZ_16M                          0x01000000
#define SZ_32M                          0x02000000
#define SZ_64M                          0x04000000
#define SZ_128M                         0x08000000
#define SZ_256M                         0x10000000
#define SZ_512M                         0x20000000

/* 
 * platform default NBLArgs address and size
 */
#ifndef CONFIG_SNSC_NBLARGS_STD_LEN
#define CONFIG_SNSC_NBLARGS_STD_LEN         SZ_4K
#endif

#ifndef CONFIG_SNSC_NBLARGS_STD_ADDR
#ifdef CONFIG_SNSC_NBL_LOWADDR
#include <asm/page.h>
#define CONFIG_SNSC_NBLARGS_STD_ADDR        ((SZ_1M - SZ_4K - CONFIG_SNSC_NBLARGS_STD_LEN) + PPC_MEMOFFSET)
#else
#define CONFIG_SNSC_NBLARGS_STD_ADDR         (SZ_1M - SZ_4K - CONFIG_SNSC_NBLARGS_STD_LEN)
#endif
#endif


/* 
 * NBLArgs address translation
 */
#ifdef CONFIG_SNSC_NBL_LOWADDR
#define nbl_to_va(x)                          (x)
#define nbl_to_pa(x)                     __pa((x))
#else
#define nbl_to_va(x)                     __va((x))
#define nbl_to_pa(x)                          (x)
#endif

#endif /* __ARCH_NBLARGS_H__ */
