/*
 *  snsc-mpu4xx_dma.h -- PPC440GP DMA controller
 *
 */
/*
 *  Copyright 2004 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */


#ifndef __SNSC_MPU4XX_DMA_H__
#define __SNSC_MPU4XX_DMA_H__


#include <linux/snsc_dma.h>
#include <asm/ppc4xx_dma.h>

#define SNSC_MPU4XX_DMA_CHANNEL_0     0x01
#define SNSC_MPU4XX_DMA_CHANNEL_1     0x02
#define SNSC_MPU4XX_DMA_CHANNEL_2     0x04
#define SNSC_MPU4XX_DMA_CHANNEL_3     0x08

#define SNSC_MPU4XX_DMA0_CHAN_MASK    0x0f


/* DMAC 1 is not currently supported */
#if NR_DMACS > 1
#define SNSC_MPU4XX_DMA_CHANNEL_4     0x10
#define SNSC_MPU4XX_DMA_CHANNEL_5     0x20
#define SNSC_MPU4XX_DMA_CHANNEL_6     0x40
#define SNSC_MPU4XX_DMA_CHANNEL_7     0x80
#endif

#define SNSC_MPU4XX_DMA1_CHAN_MASK    0xf0


#if NR_DMACS == 1
#define SNSC_MPU4XX_DMA_CHANNEL_ANY   0x0f
#else
#define SNSC_MPU4XX_DMA_CHANNEL_ANY   0xff
#endif


extern int mpu4xx_dma_request_channel(channel_t, channel_t *);
extern int mpu4xx_dma_release_channel(channel_t);
extern int mpu4xx_dma_get_channel_info(channel_t, snsc_dma_info_t *);
extern int mpu4xx_dma_set_param(channel_t, snsc_dma_param_t *);
extern int mpu4xx_dma_set_blocking_mode(channel_t, u32, void (*handler)(channel_t, snsc_dma_info_t *info, void *), void *);
extern int mpu4xx_dma_start(channel_t);


extern int mpu4xx_dma_set_user_buffer(channel_t, int, int);


#endif /* __SNSC_MPU4XX_DMA_H__ */
