/*
 *  CXD9790GG -- GPIO, interrupt, 4ch UART and I2C controller
 *
 *  Copyright 2003 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef _CXD9790_REG_H_
#define _CXD9790_REG_H_

/* CHIP ID, GPI */
#define CXD9790_CID             (0x00)
#define     CXD9790_ID              (0x02)
#define CXD9790_CREV            (0x01)
#define     CXD9790_ES1             (0x01)
#define CXD9790_CPI             (0x02)
#define CXD9790_CKEN            (0x03)
#define     CKEN_I2C                (1 << 4)
#define     CKEN_UART3              (1 << 3)
#define     CKEN_UART2              (1 << 2)
#define     CKEN_UART1              (1 << 1)
#define     CKEN_UART0              (1 << 0)

/* Interrupt */
#define CXD9790_IRCS0           (0x08)
#define CXD9790_IRCS1           (0x09)
#define CXD9790_IROUT           (0x0a)
#define CXD9790_IRCMSK          (0x0b)

/* GPIO */
#define CXD9790_GPIOZ           (0x10)
#define CXD9790_GPIOA           (0x20)
#define CXD9790_GPIOB           (0x30)
#define CXD9790_GPIOC           (0x40)
#define CXD9790_GPIOD           (0x50)
#define CXD9790_IRDM0               (0x00)
#define CXD9790_IRDM1               (0x01)
#define         IRDM_LOW            (0 << 0)
#define         IRDM_HIGH           (1 << 0)
#define         IRDM_LEVEL          (0 << 1)
#define         IRDM_EDGE           (1 << 1)
#define CXD9790_IRMSK               (0x02)
#define CXD9790_IREDC               (0x03)
#define CXD9790_IRSTS               (0x04)
#define CXD9790_POEN                (0x08)
#define CXD9790_PI                  (0x09)
#define CXD9790_PO                  (0x0a)

/* UART */
#define CXD9790_UART0           (0x80)
#define CXD9790_UART1           (0x88)
#define CXD9790_UART2           (0x90)
#define CXD9790_UART3           (0x98)

/* I2C */
#define CXD9790_ICDA            (0xa0)
#define CXD9790_ICAR            (0xa0)
#define CXD9790_ICARH           (0xa1)
#define CXD9790_ICCS            (0xa2)
#define CXD9790_ICCM            (0xa3)
#define CXD9790_ICCCL           (0xa4)
#define CXD9790_ICCCH           (0xa5)
#define CXD9790_ICATMC          (0xa6)
#define CXD9790_ICTCR           (0xa7)
#define CXD9790_ICATMS          (0xa8)
#define CXD9790_ICDS            (0xa9)
#define CXD9790_ICINT           (0xaa)
#define CXD9790_ICINTC          (0xab)

#endif /* _CXD9790_REG_H_ */
