
#ifndef I2C_ALGO_GOKU_S_H
#define I2C_ALGO_GOKU_S_H 1

#include <linux/i2c.h>


struct goku_s_i2c_algo_data {
	void *data;	/* private data for lowlevel routine */
	void (*setiic)     (void *data, __u32 ofs, __u8 val);
	__u8 (*getiic)     (void *data, __u32 ofs);
	int  (*getown)     (void *data);
	int  (*getclock)   (void *data);
	void (*waitforpin) (long tmout);

	/* local settings */
	void (*setgpio)    (void *data, __u32 ofs, __u8 val);
	__u8 (*getgpio)    (void *data, __u32 ofs);
	void (*start)      (void);
	void (*stop)       (void);
	void (*reset)      (void);
	int  (*send)       (void);
	int  (*recv)       (void);

	int udelay;
	int mdelay;
	int timeout;
};

/*** IOCTL ***/
#define I2C_RESET	0x790	/* RESET ioctl command */
#define I2C_SETSLAVEBUF	0x791	/* Set Slave buffer command */
#define I2C_GETSLAVEBUF	0x792	/* Get Slave buffer command */

struct i2c_slavebuf_data {
	unsigned int	offset;	/* buffer index, first index is zero */
	unsigned int	size;	/* get/set data size */
	unsigned char	*buf;	/* get/set data */
};


int i2c_iic_add_bus(struct i2c_adapter *adap);
int i2c_iic_del_bus(struct i2c_adapter *adap);

#endif	/* I2C_ALGO_GOKU_S_H */
