/*
 *  pci_conf.h -- do PCI configuration cycle
 *
 *  Copyright 2003 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef PCI_CONF_H_
#define PCI_CONF_H_

#include <linux/pci.h>
#include <linux/ioport.h>

#define	PCICONF_CONFTYPE_DEFAULT	0
#define	PCICONF_CONFTYPE_UNKNOWN	1
#define	PCICONF_CONFTYPE_IGNORE		2
#define	PCICONF_CONFTYPE_NORMAL		3
#define	PCICONF_CONFTYPE_PCIPCI_BRIDGE	4
#define	PCICONF_CONFTYPE_CARDBUS_BRIDGE	5

#define	PCICONF_CONFTYPE_FLG_PRESET	0x40000000

#define PCICONF_CONFTYPE_FLG_MASK	(PCICONF_CONFTYPE_FLG_PRESET)

#define PCICONF_PHASE_SCAN	0
#define PCICONF_PHASE_ALLOC	1

#define PCICONF_CALC_BAR	0
#define PCICONF_PRESET_BAR	1

typedef int (*pciconf_dev_to_conftype_t)(struct pci_dev *dev,
					 struct pci_ops *ops,
					 int phase);
typedef struct pciconf_special_dev_t {
	u16	vendor;
	u16	device;
	int	conftype;
} pciconf_special_dev_t;

int pciconf_conf(int busnum, struct pci_ops *ops,
		 pciconf_dev_to_conftype_t dev_to_conftype,
		 struct resource *io_resources[],
		 struct resource *mem_resources[]);
int pciconf_special_conftype(struct pci_dev *dev, struct pci_ops *ops,
			     pciconf_special_dev_t *list);

#endif /* !CONFI_CONF_H_ */
