/*
 * Copyright 2003 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2
 * of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
#ifndef __RDCHK_H__
#define __RDCHK_H__

extern int rdchk_get_disk_change(kdev_t dev, int call_daemon);
extern int rdchk_get_disk_insert(kdev_t dev, int call_daemon);
extern int rdchk_get_disk_state_change_count(kdev_t dev, unsigned int * ret, int call_daemon);
extern int rdchk_set_period_check(kdev_t dev, int enable);
extern int rdchk_delay_invalidate(kdev_t dev);
extern void rdchk_get_fs(kdev_t dev);
extern void rdchk_put_fs(kdev_t dev);
extern int rdchk_register_blkdev(kdev_t dev);

extern void (*rdchk_notify_revalidate_func)(kdev_t dev);

#define rdchk_notify_revalidate(dev) do{if(rdchk_notify_revalidate_func)(*rdchk_notify_revalidate_func)(dev);}while(0)

#undef RDCHK_DEBUG
#undef RDCHK_DEBUG2

#ifdef RDCHK_DEBUG
#define rdchk_printk(x...)	printk(x)
#else
#define rdchk_printk(x...)	do{}while(0)
#endif

#ifdef RDCHK_DEBUG2
#define rdchk_printk2(x...)	printk(x)
#else
#define rdchk_printk2(x...)	do{}while(0)
#endif


#endif /* ! __RDCHK_H__ */
