/**
 *  Copyright 2003,2004 Sony Corporation.
 */

#ifndef _LINUX_SCSI_PROC_EVENT_H
#define _LINUX_SCSI_PROC_EVENT_H

#ifdef __KERNEL__

struct scsi_proc_event_data {
	int flag;		/* a: add, d: delete */
	char device_name[6];	/* device_name: sda .. sdp? */
	int host_no;		/* host number */
	int channel;		/* channel */
	int id;			/* id */
	int lun;		/* lun */
	char vendor[8];		/* vendor name */
	char model[16];		/* model */
};

typedef void (*scsi_proc_event_handler)(struct scsi_proc_event_data *);

extern int scsi_proc_event_register(scsi_proc_event_handler handler);
extern int scsi_proc_event_unregister(scsi_proc_event_handler handler);

#endif /* __KERNEL__ */

#endif /* _LINUX_SCSI_PROC_EVENT_H */
