/* With non GPL files, use following license */
/*
 * Copyright 2004 Sony Corporation.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
/* Otherwise with GPL files, use following license */
/*
 * Copyright 2004 Sony Corporation.
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General  Public License as published by the
 * Free Software Foundation;  either version 2 of the  License.
 *
 * THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 * WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 * NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 * USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * You should have received a copy of the  GNU General Public License along
 * with this program; if not, write  to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _SDM_NBLARGS_H_
#define _SDM_NBLARGS_H_

#define SDM_NBLARGS_KEY         "sdminfo"

#define SDM_NBLARGS_SIZE	256

#define REGION_INFO_SIZE	64
#define SDMBLK_MAGIC		0x5342 /* "SB" */
#define REGION_INFO_VER_MAJOR	1
#define REGION_INFO_VER_MINOR	0
#define REGION_INFO_VER		((REGION_INFO_VER_MAJOR << 8) |		\
				 (REGION_INFO_VER_MINOR))
#define REGION_NAME_LEN		16

struct sdm_nblargs_t {
	u_int32_t sdmreg_size;          /* SDM registry size */

	u_int16_t sdmblk_magic;		/* SDMBLK magic */
	u_int16_t region_info_version;	/* verion of SDMBLK region info  */
	u_int32_t region_info_size;	/* size of SDMBLK region info */
	u_int32_t num_regions;		/* number of SDMBLK regions */

	u_int8_t  reserved[SDM_NBLARGS_SIZE - 
			   (sizeof(u_int32_t) * 3 + sizeof(u_int16_t) * 2)];
};

struct sdmblk_region_info_t {
	char       name[REGION_NAME_LEN];
	u_int32_t  start;
	u_int32_t  sectors;
	u_int8_t   dev;
	u_int8_t   valid;
	u_int8_t   protect;
	u_int8_t   reserved[REGION_INFO_SIZE -
			    (REGION_NAME_LEN +
			     sizeof(u_int32_t) * 2 + sizeof(u_int8_t) * 3)];
};


#ifdef NBL
int sdm_nblargs_add(u_int32_t addr);
#endif

#endif /* !_SDM_NBLARGS_H_ */
