/*
 *  snsc_dma.h -- common header file for DMA API
 *
 *  Copyright 2004 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */


#ifndef __SNSC_DMA_H__
#define __SNSC_DMA_H__


#define SNSC_DMA_ADDR_USER       (0x0001)
#define SNSC_DMA_ADDR_VIRT       (0x0002)
#define SNSC_DMA_ADDR_PHYS       (0x0004)
#define SNSC_DMA_ADDR_BUS        (0x0008)

#define SNSC_DMA_NONBLOCK        (0x1)
#define SNSC_DMA_BLOCK           (0x2)

#define SNSC_DMA_STATE_IDLE      (0x0001)
#define SNSC_DMA_STATE_BUSY      (0x0002)
#define SNSC_DMA_STATE_LAST_OK   (0x0004)
#define SNSC_DMA_STATE_LAST_NG   (0x0008)


typedef struct {
	u_int32_t state;
	int error_code;
} snsc_dma_info_t;


#ifdef CONFIG_SNSC_MPU22X
typedef struct {
	phys_addr_t addr;
	u_int32_t flags;
} snsc_dma_addr_t;

typedef u32 channel_t;
#endif /* CONFIG_SNSC_MPU22X */

#ifdef CONFIG_4xx
typedef struct {
	phys_addr_t addr;
	u_int32_t flags;
} snsc_dma_addr_t;

typedef u32 channel_t;
#endif /* CONFIG_4xx */


typedef struct {
	snsc_dma_addr_t src;
	snsc_dma_addr_t dst;
	u_int32_t len;
} snsc_dma_data_t;

typedef struct {
	snsc_dma_data_t *data;
	u_int32_t data_num;
	u_int32_t flags;
} snsc_dma_param_t;


#endif /* __SNSC_DMA_H__ */
