/*
 *  Early debug routines.
 *
 *  Copyright 2004-2006 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __SNSC_EARLY_H__
#define __SNSC_EARLY_H__

#include <linux/config.h>
#include <linux/types.h>

#if defined (CONFIG_KAISER) || defined (CONFIG_SNSC_MPU410) || \
    defined (CONFIG_FRX)    || defined (CONFIG_DTGNEXUS)    || \
    defined (CONFIG_DTG3G)  || defined (CONFIG_DTV)
#include <asm/snsc_early_ppc.h>
#endif

struct _snsc_arch_early {
	void (*puts)(const char *str);
	void (*led)(unsigned int val);
};

extern struct _snsc_arch_early snsc_arch_early;

void snsc_early_puts(const char *str);
void snsc_early_led(unsigned int val);
void snsc_disable_early_funcs(void);

#endif /* __SNSC_EARLY_H__ */
