#ifndef _SNSC_LINUX_MAJOR_H_
#define _SNSC_LINUX_MAJOR_H_

/*
 * This file has definitions for major device numbers on NSC Linux.
 *
 * Copyright 2002, 2003 Sony Corporation.
 */

/* major numbers for character devices */
#define SNSC_USB_SERIALLINK_MAJOR     120
#define SNSC_USBTG_SERIALLINK_MAJOR   121
#define SNSC_NDSP_MAJOR               122
#define SNSC_POWCTRL_MAJOR            123
#define SNSC_KEYPAD_MAJOR             124
#define SNSC_FANCTL_MAJOR             125
#define SNSC_USBTG_MAJOR              125
#define SNSC_DBMX1_MS_MAJOR           126
#define SNSC_DBMX1_GPIO_MAJOR         127

#define SNSC_FLASH_MAJOR              240    /* non-MTD FLASH device */
#define SNSC_TTYNULL_MAJOR            241    /* null console */
#define SNSC_TPAD_MAJOR               242
#define SNSC_CXD3452_MS_C_MAJOR       243    /* previously defined as 240 */
#define DTCP_IP_SOURCE_MAJOR          244    /* DTCP/IP source device */
#define DTCP_IP_SINK_MAJOR            245    /* DTCP/IP sink device */
#define DA610_MAJOR                   248
#define SNSC_SPI_MAJOR		      249
#define SNSC_CARIB_MAJOR              250
#define SNSC_NILE_MAJOR               251

/* major numbers for block devices */
#define SNSC_LTL_MAJOR                120
#define SNSC_CXD3452_MS_B_MAJOR       121    /* previously defined as 241 */

#define SNSC_SDMBLK_MAJOR             180

/* minor numbers for misc devices(major=10) */
#define ICH_GPIO_MINOR                240
#define SUPERIO_GPIO_MINOR            241
#define BU9929_MINOR                  242
#define NBLCFG_MINOR                  243
#define MPU110_PWM_MINOR	      244
#define MPU301_TVENC_MINOR            244
#define NPM_MISC_MINOR                245

#endif /* _SNSC_LINUX_MAJOR_H_ */
