/*
 *  Sony NSC Watchdog Timer Interface
 *
 *  Copyright 2003 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _SNSC_WATCHDOG_TIMER_H_
#define _SNSC_WATCHDOG_TIMER_H_

#include <linux/config.h>

#define SNSC_WATCHDOG_MAX	600 		/* max timer is 10 min */

/* machine/platform dependent routines */
struct watchdog_md {
	void		(*disable)(void);
	void		(*enable)(void);
	int		(*is_enabled)(void);
	void		(*set_count)(u_int32_t sec);
	u_int32_t	(*get_count)(void);
	void		(*heartbeat)(void);
	u_int32_t	(*get_reset_cause)(void);
	void		(*clear_reset_cause)(void);
};

struct watchdog_md *mach_watchdog_init(void);
void watchdog_init(struct watchdog_md *pwatchdog_md);

#endif /* _SNSC_WATCHDOG_TIMER_H__ */
