/*
 *  IDE driver for TDK XR1
 *
 *  Copyright 2003,2004 Sony Corporation.
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef XR1_H_
#define XR1_H_

#include <linux/types.h>
#include <linux/hdreg.h>
#include <linux/ide.h>

/*
 *  NOTE:  Each platform dependent code must define the following
 *         macros and function.
 *
 *    XR1_BASE
 *	the base address of XR1 registers which are accessed with in*()
 *	and out*()
 *    XR1_IRQ
 *	the IRQ number of XR1 interrupt
 *    void xr1_platform_init(void);
 *	the function to do platform dependent initialization
 */
#define XR1_IDEREG_OFFSET	0x200

#ifdef CONFIG_DRAGONBALL_SNSC_MPU110
#include <asm-arm/arch-dragonball/xr1.h>
#endif

#ifdef CONFIG_SNSC_MPU22X
#include <asm-mips/tx4927/snsc_mpu22x/xr1.h>
#endif

#ifdef CONFIG_SNSC_MPU23X
#include <asm-mips/cxd9802/snsc_mpu23x/xr1.h>
#endif

#if defined(__powerpc__)
#include <asm/xr1.h>
#endif

#endif /* !XR1_H_ */
